## This is Perl module for reading setup file for closure relation 
## coded by M.S. 2007.8.9
###
## $Id: Clsr_xml.pm 47 2014-11-30 03:49:39Z sekido $
##
##

package Clsr_xml;
use Exporter;

@ISA = qw(Exporter);

#@EXPORT = qw(Mjd Doy Soy Sod Print_fmt1 Print_fmt2 Print_fmt3 
#	     Print_fmt4 Print_fmt10 Str_fmt3 Set_mjd2Time 
#	     Set_time_strydhms Set_time_strymdhms);


#use AutoLoader 'AUTOLOAD';
#1;
#__END__

BEGIN{

}

use XML::TreePP;

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$){
    my $pkg = shift;
    my $fname = shift;
    unless(defined($fname)){
	print STDERR "Error in Clsr_xml.pm::Read(): file name not defined\n";
	return -1;
    }

    my $treepp = new XML::TreePP;
    $treepp->set(force_array => ["closure", "baseline", "apri"]);
    my $tree = $treepp->parsefile($fname);
    $pkg->{tree} =$tree;
    my $napr = @{$tree->{apri}};
    my $ncls = @{$tree->{closure}};
    $pkg->{napr} = $napr;
    $pkg->{ncls} = $ncls;
    return $ncls;
}

sub Napr($){
    my $pkg = shift;
    my $tree = $pkg->{tree};
    my @ano = map($_->{-no} ,@{$tree->{apri}});
    return @ano;
}
sub Ncls($){
    my $pkg = shift;
    my $tree = $pkg->{tree};
    my @cno = map($_->{-no} ,@{$tree->{closure}});
    return @cno;
}


sub Select_closure($$){
    my $pkg = shift;
    my $cno = shift;
    my $tree = $pkg->{tree};
    my @cls = grep($_->{-no} == $cno ,@{$tree->{closure}});

    if( @cls < 1 ){
	print STDERR "Specified closure number ($cno) is not found \n";
	return -1;
    }
    
    printf STDERR "Selected Closure: No=%d\n",  $cls[0]->{-no};
    my $barr = $cls[0]->{baseline};
    for(my $i=0; $i<@$barr; $i++){
	printf STDERR "  baseline = %s : %-s\n",
	$$barr[$i]->{-id},	$$barr[$i]->{'#text'};
    }

    return $cls[0];
}

sub Select_apri($$){
    my $pkg = shift;
    my $cno = shift;
    my $tree = $pkg->{tree};
    my @apr = grep($_->{-no} == $cno ,@{$tree->{apri}});

    if( @apr < 1 ){
	print STDERR "Specified a priori set number ($cno) is not found \n";
	return -1;
    }
    
    printf STDERR "Selected A priori: No=%d\n",  $apr[0]->{-no};
    my $barr = $apr[0]->{baseline};
    for(my $i=0; $i<@$barr; $i++){
	printf STDERR "  baseline = %s : %-s\n",
	$$barr[$i]->{-id},	$$barr[$i]->{'#text'};
    }

    return $apr[0];
}

