package Colm_dat;
#
# Expected format is 
# <col1> <col2>  ... ... ... <col> 
##
##  $Id: Colm_dat.pm 122 2017-04-22 08:55:14Z vlbi $
##


BEGIN {
    $MAXCOL = 50;    
}


sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_Maxcol($$){
    my $pkg = shift;
    my $m = shift;
    $MAXCOL = $m;
}
sub Maxcol(){
    return $MAXCOL;
}

sub Read($$){
    my ($pkg, $infile) = @_;
    unless(defined($infile)){
	print "E Colm_dat::Read(): input file not given\n";
	return -1;
    }
    $pkg->{file} = $file;
    unless(open(IN, "$infile")){
	print STDERR "E Failed to open file ($infile) \n";
	return -1;
    }
    my @cmnt;
    my @terms ;
    my $nclmn=0;
  #  my (@arr1, @arr2, @arr3, @arr4);
#    my @arr = (\@arr1, \@arr2, \@arr3, \@arr4);
    my @arr;
#    for(my $i=0; $i<20; $i++){  my @arr1; $arr[$i] = \@arr1;}
    my $ncol1;
    my $ndat=0;
    while(<IN>){
	chomp();
#	if(/^\#/){
	if(/^\s*\#/){
	    push(@cmnt, ($_));
	    next;
	}
	/\s*/;
	@terms = split(/\s+/,$');     # ');
	my $nt=@terms;
	next if($nt < 1);
	if($nclmn < $nt ){
	    for(my $i=$nclmn; $i<$nt; $i++){ my @arr1; $arr[$i] = \@arr1;}
	    $nclmn = @terms ;
	}
	$ncol1 = $nclmn > $MAXCOL ?  $MAXCOL : $nclmn;
	for(my $i=0; $i<$ncol1; $i++){
	    $arr[$i][$ndat] = $terms[$i];
	}
	$ndat++;
    }
    $pkg->{cmnt} = \@cmnt;
    $pkg->{ncol} = $nclmn;
    $pkg->{ndat} = $ndat;
    for(my $i=0; $i<$nclmn; $i++){
	my $lbl = sprintf("arr%d",$i);
	$pkg->{$lbl} = $arr[$i];
    }
    close(IN);
    return $ndat;
}

sub Comment($){
    my $pkg = shift;
    return @{$pkg->{cmnt}};
}

sub Ncol($){
    my $pkg = shift;
    return $pkg->{ncol};
}

## icol=0,1,2,...
sub VArr($$){
    my $pkg = shift;
    my $icol = shift;
    if($icol > $pkg->{ncol}){
	printf STDERR "Err Colm_dt::VArr(): Requested col($icol) >ncol(%d)\n",
	$pkg->{ncol};
	return ();
    }
    my $lbl = sprintf("arr%d",$icol);

    return @{$pkg->{$lbl}};
}

1;
