## Making hash database from reading the config file
##  by M.S.  2008/3/3
##  --- conf file is expected to be a list of 
##    <entry>  <value>  
###
#  @Version: $Id: Conf_hash.pm 114 2016-11-29 07:37:21Z vlbi $

package Conf_hash;
use Exporter;
use Carp;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Value($$){
    my ($pkg,$key) = @_;
    $pkg->{$key};
}

sub KeyList($){
    my $pkg = shift;
    unless( %$pkg ){
	print "E Conf_hash::KeyList() failed cause of undefined hash\n";
	return undef;
    }
    keys(%{$pkg});
}

sub Read($$){
    my ($pkg,$fname) = @_;
    unless (defined($fname)){
	print STDERR "Err in Conf_hash::Read(): fname undefined\n";
	return -1;
    }
    unless( open(IN, $fname) ){
	print STDERR "Error: Failed to open file($fname) \n";
	return -1;
    }
    my $nent=0;
    while(<IN>){
	next if(/^\#/);
#	if(/(\S+)[\s\t]+(\S*.*\S)\s*/){
	if(/(\S+)[\s\t]+(\S+)\s*/){
	    my $t1 =$1;
	    my $t2 = $2;
	    chomp($t1);
	    chomp($t2);
	    $pkg->{$t1}=$t2;
	    $nent++;
	}
    }
    return $nent;
}

sub Print($){
    my $pkg = shift;
    my $cnt=0;
    print "#---Config Parameters ---\n";
    foreach my $h (keys(%$pkg)){
	printf "%2d: %-12s  %s\n", $cnt,$h, $pkg->{$h};
	$cnt++;
    }
    print "#---------------------------\n";
}

1;
