## Get Configration file in XML form
## Expecting <root Entry>
##             <entry tags>
##                <entry elements>
#  @Version: $Id: Conf_xml.pm 47 2014-11-30 03:49:39Z sekido $

package Conf_xml;
use Exporter;
use Carp;
use XML::DOM;

@ISA = qw(Exporter);

# @EXPORT = qw(chk_r chk_1);
#	     Print_fmt4 Print_fmt10 Str_fmt3 Set_mjd2Time 

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Get_Entry($$){
    my $pkg = shift;
    my $entry = shift;
    my $tgt = &chk_1($pkg->{root}, $entry);
    unless(defined($tgt)){
	print STDERR "Error $entry entry does not found\n";
	return undef;
    }
    $pkg->{node} = $tgt;
    return $tgt;
}

## Get entry list in the node, which is called just befure.
sub Get_EntList($$){
    my $pkg = shift;
    my $entry = shift;
    my $ele = $pkg->{node};
    my @files = ();

    if($ele->getNodeType == ELEMENT_NODE &&
       $ele->hasChildNodes){
	my $children = $ele->getChildNodes;
	my $nch = $children->getLength;
	foreach(0 .. $nch-1){
	    my $child =  $children->item($_);
	    if($child->getNodeType == ELEMENT_NODE && 
	       $child->getTagName eq $entry &&
	       $child->hasChildNodes){
		$gchs = $child->getChildNodes;
		$ngch = $gchs->getLength;
		for(my $i=0; $i<$ngch; $i++){
		    push(@files,($gchs->item($i)->getData));
		}
	    }
	}
    }

    return @files;

}

sub Set_root($$$){
    my $pkg = shift;
    my $xmlfile = shift;
    my $root_entry = shift;

    $/=undef;
    unless(open(IN,$xmlfile)){
	print STDERR "Cannot open file $infile\n";
	return undef;
    }
    my $xml = <IN>; close(IN);
    $/ = "\n";
    my $p = new XML::DOM::Parser;
    my $doc;
    eval {$doc  = $p->parse($xml)};
    if ($@){
	print STDERR "XMLʸϤǤ : $@\n";
	return undef;
    }    
    
    my $root = &chk_r($doc, $root_entry);

    $pkg->{root} = $root;
    unless(defined($root)){
	print STDERR "Error $root_entry entry does not found\n";
	exit(1);
    }
    
    return $root;
}

## Check tagname Recursively
sub chk_r($$){
    my $doc = shift;
    my $entry = shift;
    if($doc->getNodeType == ELEMENT_NODE){
	if($doc->getTagName eq $entry){    return $doc;	}
	else{ return undef;}
    }elsif($doc->hasChildNodes ){
	my $children = $doc->getChildNodes;
	my $n = $children->getLength;
	foreach (0 .. $n-1){
	    my $ret = &chk_r($children->item($_),$entry);
	    if(defined($ret)){ return $ret;}
	}
	return undef;
    }
}

sub chk_1($$){
    my $doc = shift;
    my $entry = shift;
    if($doc->getNodeType == ELEMENT_NODE){
	if($doc->getTagName eq $entry){    return $doc;	}
	elsif($doc->hasChildNodes ){ 
	    my $children = $doc->getChildNodes;
	    my $n = $children->getLength;
	    foreach (0 .. $n-1){
		my $gch = $children->item($_);
		if($gch->getNodeType == ELEMENT_NODE &&
		   $gch->getTagName eq $entry){
		    return $gch;
		}
	    }
	}
    }
    return undef;
}
