#
#  Correlation agent monitor Module.
#  @Auther: by M.Sekido 
#  @Date:  2007.10.23 
#  @Version: $Id: Cor_monit.pm 47 2014-11-30 03:49:39Z sekido $
#
#
package Cor_monit;
use Exporter;
# use lib "$ENV{HOME}/prog/perl/module";
use Logsys;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
#use Term::ANSIScreen qw/:color :cursor :screen :keyboard/;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

DESTROY{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_logfile($$){
     my ($pkg,$logfile) = @_;
     my $logsys = new Logsys;
     return -1 if($logsys->Set_logfile($logfile) <0);
     $pkg->{logsys}=$logsys;
 }

sub Message($$){
    my ($pkg,$msg) = @_;
    return unless(defined($pkg->{logsys}));
    $pkg->{logsys}->Message($msg);
}

sub Set_CorSrvs($\@){
    my ($pkg, $hlist) = @_;
    $pkg->{hosts} = $hlist;
}

sub CorSrvs($){
    my $pkg = shift;
    $pkg->{hosts}
}
sub Set_dbg($){
    my $pkg = shift;
    $pkg->{dbg}=1;
}

sub Dbg($){
    my $pkg = shift;
    if(defined($pkg->{dbg}) && $pkg->{dbg} ==1){
	return 1;
    }else{
	return 0;
    }
}

## Summarize the survey data 
sub Sort_Job($){
    my $pkg = shift;
    my $joblist = $pkg->{job_list};

    my @jhost_f = grep(/FNSH/,keys(%{$joblist}));
#    my @jhost_w = grep(/WAIT/,keys(%{$joblist}));
    my @jhost_e = grep(/EXEC/,keys(%{$joblist}));
    
    my @j_list;
    ## Finished List
    foreach my $h (@jhost_f){
	my $tmp = $joblist->{$h};
	my @terms = split(/\s+/,$tmp);
	next if(@terms <1);
	push(@j_list,(@terms));
    }
    my @f_list = sort {$a cmp $b} @j_list;
    my @bids = &Ext_jobBID(\@f_list);

    ## Executing list
    foreach my $h (@jhost_ef){
	my $tmp = $joblist->{$h};
	my @terms = split(/\s+/,$tmp);
	next if(@terms <1);
	push(@j_list,(@terms));
    }
    my @e_list = sort {$a cmp $b} @j_list;

    $pkg->{bid} = \@bid;
    $pkg->{flist} = \@f_list;
    $pkg->{elist} = \@e_list;
}

sub Print_list($;$){
    my $pkg = shift;
    my $out = shift;
    $out = STDERR unless(defined($out));
    my $bid = $pkg->{bid};
    my $flst = $pkg->{flist};
    my $elst = $pkg->{elist};
    my $tb_ent = $pkg->{time_baseID_entry};
    my @komb_ent;
    
    my $cnt=0;
    my ($tm1,$l1);	
    my @grpid;
    foreach my $l (@{$flst}){
	unless($l =~m!(\d{4}/\d{3}-\d\d:\d\d:\d\d):(\S\S):(\S)!){
	    print STDERR "Error in Cor_monit::Print_list(): FLIST entry is wrong\n";
	    printf STDERR "Entory= %s\n", $l;
	    next;
	}
	next if(defined($l1) && $l1 eq $l);
	my $tm = $1;	
	my $base_id = $2;
	my $fid = $3;
	if(defined($tm1) && $tm eq $tm1){
	    print $out " $fid";
	    push(@grpid,($fid));
	}else{
	    printf $out "\n$tm $base_id $fid";
	    @grpid= ($fid);
	}
	my $ent = sprintf "%s:%2s",$tm,$base_id;
	if(!defined($tb_ent->{$ent}) || $tb_ent->{$ent} <5  ){
	    $tb_ent->{$ent} = @grpid;
	    if($tb_ent->{$ent} ==4){
		push(@komb_ent, ($ent));
		$tb_ent->{$ent} =5;
	    }
	}
	
	$tm1 = $tm;
	$l1 = $l;
    }
    $pkg->{time_baseID_entry} = $tb_ent;
    print $out "\n";
    return @komb_ent;
}

sub Print_HostJob($;$){
    my $pkg = shift;
    my $out = shift;
    $out = STDERR unless(defined($out));
    my $srvs = $pkg->{hosts};
    my $joblist = $pkg->{job_list};

    print $out "##Number of jobs: Finish, Wait, Executing\n";
    foreach my $h (@{$srvs}){
	my @njob = $pkg->Host_job($h);
	my $tmp = $joblist->{"$h:EXEC"};
	if( $njob[2]){
	    printf $out " %8s     %3d   %3d    %3d  %s\n",
	    $h, $njob[0], $njob[1],$njob[2], $tmp;
	}else{
	    printf $out " %8s     %3d   %3d    %3d\n",
	    $h, $njob[0], $njob[1],$njob[2];
	}
    }
    print $out "##---------------------------------------\n";
}


## Return number (finish, wait, execting) jobs 
sub Host_job($$){
    my $pkg = shift;
    my $h = shift;
    my $joblist = $pkg->{job_list};
    my $ftmp = $joblist->{"$h:FNSH"};
    my $etmp = $joblist->{"$h:EXEC"};
    my @jnum = (0,0,0);
    if(defined($ftmp)){
	my @fterms = split(/\s+/,$ftmp);
	$jnum[0] = @fterms if(@fterms >0);
    }
    if(defined($etmp)){
	my @eterms = split(/\s+/,$etmp);
	$jnum[2] = @eterms if(@eterms >0);
    }
    return @jnum;
}

sub Ext_jobBID(\@){
    my $lst = shift;
    my @bid = ();
    foreach my $l (@{$lst}){
	unless($l =~m!\d{4}/\d{3}-\d\d:\d\d:\d\d:(\S\S):\S!){
	    print STDERR 
		"Error: Cor_monit::Ext_jobBID():Job Entry Format is wrong\n";
	    print STDERR
		"Entory= $l\n";
	    next;
	}
	my $b = $1;
	push(@bid, ($b)) unless(grep(/$b/,@bid));
    }
    return @bid;
}

## Survey if the cor-servers are free or busy.
sub Survey($){
    my $pkg = shift;
    my $hlist = $pkg->CorSrvs();
    my $dbg = $pkg->Dbg();
    
    my $nhost = @$hlist;
    my %job_list;
    for(my $ihost = 0; $ihost<$nhost; $ihost++){
	my $h = $$hlist[$ihost];
	unless ( $h =~/(\S+):(\d+)/){
	    print STDERR "Error in Cor_com_clt::Survey(): host-entry ($h) unmatched\n";
	    next;
	}
	printf STDERR "Survery to %s ...",$h if($dbg);
	$pkg->Message( "Survery to $h ...");
	my $host = $1;
	my $port = $2;
	my $remote = IO::Socket::INET->new(Proto    => "tcp",
					   PeerAddr => $host,
					   PeerPort => $port );
	unless(defined($remote)){
	    print STDERR 
		"Error in Cor_monit::Survey: Failed to make connection to $h \n";
	    $pkg->Message("Failed connection to $h\n",1);
	    next;
	}

#	print STDERR "Success, ";
#	$pkg->Message("Success, ",1); 
	select($remote); $|=1;
	select(STDERR);
	print $remote "JobsList?\n";
	my $njobs = 0;
	for( my $i=0; $i<3; $i++){
	    my $line = <$remote>;
#	    print STDERR "msg=$_";
	    if($line =~/Finished:\s*(\S*.*)/){
		$i = 0;
		$job_list{"$h:FNSH"} = $1;
		print STDERR "$h:FNSH = $1\n" if($pkg->Dbg());
	    }elsif($line =~/Waiting:\s*(\S*.*)/){
		$i = 1;
		$job_list{"$h:WAIT"} = $1;
		print STDERR "$h:WAIT = $1\n" if($pkg->Dbg());
	    }elsif($line =~/Executing:\s*(\S*.*)/){
		$i = 2;
		$job_list{"$h:EXEC"} = $1;
		print STDERR "$h:EXEC = $1\n" if($pkg->Dbg());
	    }else{
		print STDERR
		    "Protocol error in Cor_monit::Survey(): return=$line\n"; 
		next;
	    }
	} # loop for 3 times
	close($remote);
    } #loop for host
    $pkg->{job_list} = \%job_list;
    return 0;
}


1;
