#
#  Cout data  Module.
#  @Auther: by M.Sekido 
#  @Date:  2014.7.17 
#  @Version: $Id: Cout_dat.pm 47 2014-11-30 03:49:39Z sekido $
#
#
package Cout_dat;
use Exporter;
use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;
#use Term::ANSIScreen qw/:color :cursor :screen :keyboard/;
@ISA = qw(Exporter);

@EXPORT = qw(Read PcalX PcalY);

BEGIN{
    my $a=0;
};

DESTROY{

};

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

# Return (Npp, $msg)
sub Read($$){
    my ($pkg,$coutfile) = @_;
    
    unless(open(IN,$coutfile)){
	print STDERR "Cannot open coutfile:$coutfile \n";
	return -1;
    }
    
    my ($Nch, $Nlag);
    my $mline = 0;
    my $err=0;
    my $msg ="";
    my (@PcalAmp, @PcalPhase);
    my ($ipp,$npp)=(0,0);
    while(<IN>){
	if($mline==0 && /^\#FORMAT(\d+)/){
	    $pkg->{Format} = $1;
	    $mline++;
	}elsif($mline==1 && /(\S+)/){
	    $pkg->{PrcHost} = $1;
	    $mline++;
	}elsif($mline==2 && /(\S+)/){
	    $pkg->{ExpCode} = $1;
	    $mline++;
	}elsif($mline==3 && /(\S+)/){
	    $pkg->{iScan} = $1;
	    $mline++;
	}elsif($mline==4 && /(\S+)/){
	    $pkg->{BaseID} = $1;
	    $mline++;
	}elsif( $mline==5 ){
	    my @terms = split(/\s+/);
	    if(@terms < 7){ 
		$msg = "E CorPrcTime is less than 7; line= $_"; $err++;last;}
	    my $t1 = new Time_lib;
	    $t1->Set_time_ydhms($terms[0],$terms[1],
				$terms[2],$terms[3],$terms[4]);
	    $pkg->{CorPrcEpoch} = $t1;
	    $mline++;
	}elsif($mline==6 && /(\S+)/){
	    $pkg->{XstName} = $1;
	    $mline++;
	}elsif($mline==7){
	    my @terms = split(/\s+/);
	    if(@terms < 3){ 
		$msg = "E X-Coord data less than 3"; $err++;last;}
	    $pkg->{Xpos} = \@terms;
	    $mline++;
	}elsif($mline==8 && /(\S+)/){
	    $pkg->{XFileName} = $1;
	    $mline++;
	}elsif($mline==9 && /(\S+)/){
	    $pkg->{YstName} = $1;
	    $mline++;
	}elsif($mline==10){
	    my @terms = split(/\s+/);
	    if(@terms < 3){ 
		$msg = "E Y-Coord data less than 3"; $err++;last;}
	    $pkg->{Ypos} = \@terms;
	    $mline++;
	}elsif($mline==11 && /(\S+)/){
	    $pkg->{YFileName} = $1;
	    $mline++;
	}elsif($mline==12 && /(\S+)/){
	    $pkg->{SrcName} = $1;
	    $mline++;
	}elsif($mline==13){
	    my @terms = split(/\s+/);
	    if(@terms < 3){ 
		$msg = "E Src-Ra data less than 3"; $err++;last;}
	    $pkg->{SrcRa} = \@terms;
	    $mline++;
	}elsif($mline==14){
	    my @terms = split(/\s+/);
	    if(@terms < 3){ 
		$msg = "E Src-Dec data less than 3"; $err++;last;}
	    $pkg->{SrcDec} = \@terms;
	    $mline++;
	}elsif($mline==15 && /(\S+)/){
	    $pkg->{SrcPosEpoch} = $1;
	    $mline++;
	}elsif($mline==16){
	    my @terms = split(/\s+/);
	    if(@terms < 3){ 
		$msg = "E SideRealTime data less than 3"; $err++;last;}
	    $pkg->{SideRealTime} = \@terms;
	    $mline++;
	}elsif($mline==17){
	    my @terms = split(/\s+/);
	    if(@terms < 5){ 
		$msg = "E ObsStart less than 5"; $err++;last;}
	    my $t1 = new Time_lib;
	    $t1->Set_time_ydhms($terms[0],$terms[1],
				$terms[2],$terms[3],$terms[4]);
	    $pkg->{ObsStartEpoch} = $t1;
	    $mline++;
	}elsif($mline==18){
	    my @terms = split(/\s+/);
	    if(@terms < 5){ 
		$msg = "E ObsStop less than 5"; $err++;last;}
	    my $t1 = new Time_lib;
	    $t1->Set_time_ydhms($terms[0],$terms[1],
				$terms[2],$terms[3],$terms[4]);
	    $pkg->{ObsStopEpoch} = $t1;
	    $mline++;
	}elsif($mline==19){
	    my @terms = split(/\s+/);
	    if(@terms < 5){ 
		$msg = "E PRT less than 5"; $err++;last;}
	    my $t1 = new Time_lib;
	    $t1->Set_time_ydhms($terms[0],$terms[1],
				$terms[2],$terms[3],$terms[4]);
	    $pkg->{ObsPRT} = $t1;
	    $mline++;
	}elsif($mline==20 && /(\S+)/){
	    $pkg->{tau0} = $1;
	    $mline++;
	}elsif($mline==20 && /(\S+)/){
	    $pkg->{tau0} = $1;
	    $mline++;
	}elsif($mline==21 && /(\S+)/){
	    $pkg->{tau1} = $1;
	    $mline++;
	}elsif($mline==22 && /(\S+)/){
	    $pkg->{tau2} = $1;
	    $mline++;
	}elsif($mline==23 && /(\S+)/){
	    $pkg->{tau3} = $1;
	    $mline++;
	}elsif($mline==24 ){
	    my @terms = split(/\s+/);
	    $pkg->{ClockOffset} = \@terms;
	    $mline++;
	}elsif($mline==25 && /(\S+)/){
	    $pkg->{ClockRate} = $1;
	    $mline++;
	}elsif($mline==26){
	    my @terms = split(/\s+/);
	    if(@terms < 3){ 
		$msg = "E ERP data less than 3"; $err++;last;}
	    $pkg->{ERP} = \@terms; # dUT1[sec],Xwob[asec],Ywob[asec]
	    $mline++;
	}elsif($mline==27 && /(\S+)/){
	    $Nch=$1;
	    $pkg->{Nch} = $Nch;
	    my (@rf,@pcalf, @ulsb);
	    for(my $i=0;$i<$Nch; $i++){
		my $line = <IN>;
		my @terms = split(/\s+/,$line);
		if(@terms < 3){ 
		    $msg = "E RF/Pcal data less than 3"; $err++;last;}
		$rf[$i] = $terms[0];
		$pcalf[$i] = $terms[1];
		$ulsb[$i] = $terms[2];
	    }
	    $pkg->{RF} = \@rf;
	    $pkg->{Pcalf} = \@pcalf;
	    $pkg->{ULSB} = \@ulsb;
	    $mline += 2;
	}elsif($mline==29 && /(\S+)/){
	    $pkg->{Srate} = $1; # [Hz]
	    $mline++;
	}elsif($mline==30 && /(\S+)/){
	    $pkg->{Qbit} = $1; # [1/2/4/8]
	    $mline++;
	}elsif($mline==31 && /(\S+)/){
	    $pkg->{Tpp} = $1; # [sec]
	    $mline++;
	}elsif($mline==32 && /(\S+)/){
	    $pkg->{Tintg} = $1; # [sec]
	    $mline++;
	}elsif($mline==33 && /(\S+)/){
	    $Nlag = $1;
	    $pkg->{NLag} = $Nlag; 
	    $mline++;
	}elsif($mline==34 && /(\S+)/){
	    $pkg->{Npp} = $1; 
	    $mline++;
	}elsif($mline > 34 ){
	    if(/PP\#\s+(\d+)/){
		$ipp = $1 -1;
		if($npp != $ipp){
		    printf STDERR "Warn: ipp($ipp) != npp($npp)\n";
		}
		next;
	    }
	    if(/X-PCAL/){
		my (@pamp,@pphase);
		for(my $i=0; $i<$Nch; $i++){
		    my $line = <IN>;
		    my @terms = split(/\s+/,$line);
		    if(@terms < 6){ 
			$msg = sprintf("E Pcal[%d] data less than 6; line=$line",$ipp);
			$err++;last;}
		    $pamp[$i] = $terms[4];
		    $pphase[$i] = $terms[5];
		}
		$PcalAmp[0][$ipp] = \@pamp;
		$PcalPhase[0][$ipp] = \@pphase;
		next;
	    }if(/Y-PCAL/){
		my (@pamp,@pphase);
		for(my $i=0; $i<$Nch; $i++){
		    my $line = <IN>;
		    my @terms = split(/\s+/,$line);
		    if(@terms < 6){ 
			$msg = sprintf("E Pcal[%d] data less than 6",$ipp);
			$err++;last;}
		    $pamp[$i] = $terms[4];
		    $pphase[$i] = $terms[5];
		}
		$PcalAmp[1][$ipp] = \@pamp;
		$PcalPhase[1][$ipp] = \@pphase;
		$npp++;
		next;
	    }
	}

	
    }
    close(IN);
    $npp--;
    $pkg->{pcalphase} = \@PcalPhase;
    $pkg->{pcalamp} = \@PcalAmp;
    $pkg->{npp} = $ipp;

    if($err >0){
	return (-1, $msg);
    }else{
	return ($npp,$msg);
    }
}

# Return Pcal Xarray at ich (0-3);
sub PcalX($$){
    my $pkg = shift;
    my $ich = shift;
    my $nch = $pkg->{Nch};
    my $msg = "";
    my (@pharr, @amparr, $npp);
    if($ich > $nch-1 || $ich < 0){
	$msg = "Error: ich($ich) > $nch($nch) ";
	$npp = -1;
	return (\@amparr, \@pharr, $npp, $msg);
    }

    $npp = $pkg->{npp};
    my $pPcalAmp = $pkg->{pcalamp};
    my $pPcalPhase = $pkg->{pcalphase};
    for(my $i=0; $i<$npp; $i++){
	$amparr[$i] = $$pPcalAmp[0][$i][$ich];
	$pharr[$i] = $$pPcalPhase[0][$i][$ich];
    }

    return (\@amparr, \@pharr, $npp, $msg);
    
}

# Return Pcal Y array at ich (0-3);
sub PcalY($$){
    my ($pkg, $ich) = @_;
    my $nch = $pkg->{Nch};
    my $msg = "";
    my (@pharr, @amparr, $npp);
    if($ich > $nch-1 || $ich < 0){
	$msg = "Error: ich($ich) > $nch($nch) ";
	$npp = -1;
	return (\@amparr, \@pharr, $npp, $msg);
    }

    $npp = $pkg->{npp};
    my $pPcalAmp = $pkg->{pcalamp};
    my $pPcalPhase = $pkg->{pcalphase};
    for(my $i=0; $i<$npp; $i++){
	$amparr[$i] = $$pPcalAmp[1][$i][$ich];
	$pharr[$i] = $$pPcalPhase[1][$i][$ich];
    }
    return (\@amparr, \@pharr, $npp, $msg);
}

sub Nch($){
    my $pkg = shift;
    $pkg->{Nch};
}

sub Npp($){
    my $pkg = shift;
    $pkg->{npp};
}

sub Stname($){
    my $pkg = shift;
    (  $pkg->{Xstname},  $pkg->{Ystname});
}

sub ObsStart($){
    my $pkg = shift;
    $pkg->{ObsStartEpoch};
}

sub ObsStop($){
    my $pkg = shift;
    $pkg->{ObsStopEpoch};
}

sub ObsPRT($){
    my $pkg = shift;
    $pkg->{ObsPRT};
}

sub Tpp($){
    my $pkg = shift;
    $pkg->{Tpp};
}

1;
