#  @Version: $Id: Degree.pm 47 2014-11-30 03:49:39Z sekido $
#
package Degree;
use Exporter;
use Carp;
use overload
    "+"  => "plus";
#    "!=" => "notequal",
#    "==" => "equal",
#    ">"  => "gt",
#    "<"  => "lt",
#    "-"  => "minus",

@ISA = qw(Exporter);

#@EXPORT = qw();

use Mjd;

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Str_src($){
    my $pkg = shift;
    my $d = $pkg->{deg};
    my $m = $pkg->{min};
    my $s = $pkg->{sec};
    sprintf "%+03d%02d%05.2f", $d,$m,$s;
}

sub Set_dms($$$$){
    my ($pkg, $d,$m,$s) = @_;
    unless(defined($s)){
	print STDERR "Error in Degree::Set_dms(): Unexpected format \n";
	exit(-1);
    }
    my $n=0;
    if($s >=60){
	$n = int($s/60);
	$m += $n;
	$s -= $n*60;
    }
    if($m >=60){
	$n = int($m/60);
	$d += $n;
	$m -= $n*60;
    }
    
    $pkg->{deg} = $d;
    $pkg->{min} = $m;
    $pkg->{sec} = $s;
    
}

sub Normalize($){
    $pkg = shift;
    my $d = $pkg->{deg};
    my $m = $pkg->{min};
    my $s = $pkg->{sec};
    unless(defined($d) && defined($m) && defined($s)){
	croak "Error in Degree::plus(): argument must be Degree.\n";
	exit(1);
    }

    if($s <0 || $s >=60){
	my $n = int($s /60);
	$s -= $n*60;
	$m += $n;
	if($s <0){
	    $m --;
	    $s += 60;
	}
    }

    if($m <0 || $m >= 60){
	my $n = int($m/60);
	$m -= $n*60;
	$d += $n;
	if($m <0){
	    $d --;
	    $m += 60;
	}
    }

    if($d <0 || $d >= 360){
	my $n = int($d/360);
	$d -= $n*360;
	$d += 360 if($d <0);
    }
    
    $pkg->{deg} = $d;
    $pkg->{min} = $m;
    $pkg->{sec} = $s;
    
}

sub plus($$){
    my ($pkg,$sec) = @_;
    my $d = $pkg->{deg};
    my $m = $pkg->{min};
    my $s = $pkg->{sec};
    unless(defined($d) && defined($m) && defined($s)){
	croak "Error in Degree::plus(): argument must be Degree.\n";
	exit(1);
    }
    
    $s += $sec;
    my $d1 = new Degree;
    $d1->Set_dms($d,$m,$s);
#    $pkg->{sec} = $s;
    $d1->Normalize();
    return $d1;
}
