# @Version: $Id: GPS_taki.pm 50 2014-11-30 08:54:58Z sekido $
# Module for GPS time comparison analysis result done by Takiguchi-san
package GPS_taki;
use Exporter;
use Carp;

@ISA = qw(Exporter);

#@EXPORT = qw(Mjd Doy Soy Sod Print_fmt1 Print_fmt2 Print_fmt3 
#	     Print_fmt4 Print_fmt10 Str_fmt3 Set_mjd2Time 
#	     Set_time_strydhms Set_time_strymdhms Set_time_ydhms, 
#            Set_time_Max);
#  Max time = 3000/1/1 

use Time_lib;

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$){
    my $pkg = shift;
    my $fname = shift;
    
    unless(open(IN, $fname)){
	print STDERR "Error: GPS-taki::Read(): Failed to opne file($fname)\n";
	return -1;
    }
    
    my $cy=7;  # Column Number of Year
    my (@mjd, @td, @tst1, @tst2, @tarr, @ymdhms);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	my @terms = split(/\s+/);
	$mjd[$cnt] = $terms[0];
	$td[$cnt] = $terms[1];
	$tst1[$cnt] = $terms[2];
	$tst2[$cnt] = $terms[3];
	my $t1 = new Time_lib;
	my @ymdhms = ($terms[$cy],$terms[$cy+1],$terms[$cy+2],$terms[$cy+3],
		      $terms[$cy+4],$terms[$cy+5] );
	$t1->Set_time_ymd(@ymdhms);
	$tarr[$cnt] = $t1;
	$cnt++;
    }

    close(IN);
    $pkg->{TimeArr} = \@tarr;
    $pkg->{MJD} = \@mjd;
    $pkg->{TD} = \@td;  # Time Difference 
    $pkg->{Tst1} = \@tst1;
    $pkg->{Tst2} = \@tst2;
    
    return $cnt;
}

sub MJDarr($){
    my $pkg = shift;
    return @{$pkg->{MJD}};
}

#Time Difference array
sub TDarr($){ # [nsec]
    my $pkg = shift;
    return @{$pkg->{TD}};
}

sub Tarr($){
    my $pkg = shift;
    return @{$pkg->{TimeArr}};
}


1;
