#  @Version: $Id: Gdif_fmt.pm 48 2014-11-30 03:51:32Z sekido $

# EXpected data format is 
# # yd hms mjd tau rambg nambg amp derr snr elx ely (deg)
# 2005/307 21:32:25.000 53677.8975115700014  1.99646143793e-06 3C273B   10000000.0000 3.4529e-03 5.80e-12 196.53 39.59 45.19

package Gdif_fmt;
use Exporter;

use Atm_Moran;
use Time_lib;
@ISA = qw(Exporter);

#@EXPORT = qw(Read Print_org Print_crct_out );

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Del_crr($$){
    my ($this, $idat) = @_;
    my $ndat = $this->{ndat};
    my $del_crr;
    if( $idat < 0 || $idat >= $ndat){
	print STDERR "Error: Del_crr($idat), index out of range ($ndat)\n";
	exit(1);
    }
    
    return $del_crr[$idat];
}

sub Del_arr($){
    my $this = shift;
    $this->{del};
}
sub SNR_arr($){
    my $this = shift;
    $this->{snr};
}
sub Derr_arr($){
    my $this = shift;
    $this->{derr};
}
sub AmbFarr($){
    my $this = shift;
    $this->{ambf};
}
sub SRC_arr($){
    my $this = shift;
    $this->{src};
}
sub Amp_arr($){
    my $this = shift;
    $this->{amp};
}

sub Print_org($$;$){ # Print Original data
    my ($this, $idat, $out) = @_;
    my $p = caller;
    my $H;
    if(defined($out)){
	$H = $p . "::" . $out;
#	$H =  $out;
    }else{
	$H = STDOUT;
    }
    my $tm = $this->{time};
    my $del = $this->{del};
    my $src = $this->{src};
    my $ambf = $this->{ambf};    
    my $amp = $this->{amp};
    my $derr = $this->{derr};
    my $snr = $this->{snr};    
    my $elx = $this->{elx};
    my $ely = $this->{ely};

    $tm[$idat]->Print_fmt1($H);
    print $H " %19.13f %18.11e %8s %11.3f %10.4e %8.2e %6.2f %6.2f %6.2f %10.3e\n", 
    $$tm[$idat]->Mjd(), $$del[$idat], $$src[$idat], $$ambf[$idat], 
    $$amp[$idat], $$derr[$idat], $$snr[$idat], 
    $$elx[$idat], $$ely[$idat];
}

sub Tdat($$){
    my ($this, $i) = @_;
    my $tm = $this->{time};
    $$tm[$i];
}

sub Tarr($){
    my $this = shift;
    $this->{time};
}

sub Ndat($){
    my $this = shift;
    $this->{ndat};
}

sub Print_crct_out($$;$$){ # Print Corrected  data
    my ($this, $idat, $out,$flag) = @_;
    my $p = caller;
    my $H;
    if(defined($out)){
	$H = $p . "::" . $out;
#	$H =  $out;
    }else{
	$H = STDOUT;
    }
    my $del_crrx = $this->{del_crrx};
    my $del_crry = $this->{del_crry};
    my $tm = $this->{time};
    my $src = $this->{src};
    my $del = $this->{del};
    my $ambf = $this->{ambf};
    my $amp = $this->{amp};
    my $derr = $this->{derr};
    my $snr = $this->{snr};
    my $elx = $this->{elx};
    my $ely = $this->{ely};
    my $del_crr = $this->{del_crr};

    print $H "#UTC Mjd, Delay Src, ambgf, Amp, derr, SNR, Elx, Ely, Delcrr(sec)\n"    
	if( defined($flag) && $flag ==1);
    my $new_del = $$del[$idat] + $$del_crr[$idat];

    $$tm[$idat]->Print_fmt1($H);
    printf $H " %19.13f %18.11e %8s %11.3f %10.4e %8.2e %6.2f %6.2f %6.2f %+10.3e %+11.4e %+11.4e\n", 
    $$tm[$idat]->Mjd(), $new_del, $$src[$idat], $$ambf[$idat], 
    $$amp[$idat], $$derr[$idat], $$snr[$idat], 
    $$elx[$idat], $$ely[$idat], $$del_crr[$idat],
    $$del_crrx[$idat],$$del_crry[$idat];

}

sub Print_crct_out2($$;$$){ # Print Corrected data
    my ($this, $idat, $out,$flag) = @_;
    my $p = caller;
    my $H;
    if(defined($out)){
	$H = $p . "::" . $out;
#	$H =  $out;
    }else{
	$H = STDOUT;
    }
    my $tm = $this->{time};
    my $src = $this->{src};
    my $del = $this->{del};
    my $ambf = $this->{ambf};
    my $amp = $this->{amp};
    my $derr = $this->{derr};
    my $snr = $this->{snr};
    my $elx = $this->{elx};
    my $ely = $this->{ely};
    my $atmcrr = $this->{atmc};
    my $del_crr = $this->{del_crr};

    print $H "#UTC Mjd, Delay Src, ambgf, Amp, derr, SNR, Elx, Ely, Delcrr1(sec), Delcrr2,...\n"    
	if( defined($flag) && $flag ==1);
    my $new_del = $$del[$idat] + $$del_crr[$idat];

    $$tm[$idat]->Print_fmt1($H);
    printf $H " %19.13f %18.11e %8s %11.3f %10.4e %8.2e %6.2f %6.2f %6.2f",
    $$tm[$idat]->Mjd(), $new_del, $$src[$idat], $$ambf[$idat], 
    $$amp[$idat], $$derr[$idat], $$snr[$idat], 
    $$elx[$idat], $$ely[$idat];
    printf $H " %+10.3e", $$atmcrr[$idat] if(defined($atmcrr));
    printf $H " %+11.3e\n", $$del_crr[$idat];

}

sub Intrp0($\@\@){
    my ($sog, $tarr, $yarr) = @_;
    
    if( $$tarr[0] == $sog){
	return ($yarr);
    }else{
	my $dt = $sog - $$tarr[0];
	my $dt0 = $$tarr[1] - $$tarr[0];
	my $atmx= ($$yarr[1] - $$yarr[0])*$dt/$dt0 + $$yarr[0];
	return $atmx;
    }	
}

sub Intrp($\@\@){
    my ($sog, $tarr, $yarr) = @_;

    my @atmx;

    if( $$tarr[0] == $sog){
	return (@$yarr[0]);
    }else{
	my $dt = $sog - $$tarr[0];
	my $dt0 = $$tarr[1] - $$tarr[0];
	$atmx[0]= ($$yarr[0][1] - $$yarr[0][0])*$dt/$dt0 + $$yarr[0][0];
	$atmx[1]= ($$yarr[1][1] - $$yarr[1][0])*$dt/$dt0 + $$yarr[1][0];
	return @atmx;
    }	
}

sub Make_correction(\@\@\@\@){
    ($this,$txarr, $atmxarr, $tyarr, $atmyarr) = @_;
    
    my $nx = @$txarr;
    my $ny = @$tyarr;
    my $ndat = $this->{ndat};
    my $tm = $this->{time};

    my ($ig, $ix, $iy) = (0,0,0);
    my (@sox, @soy);
    $ix =$iy = 1;
    my $atm_fnc = new Atm_Moran;
    my (@del_crr);
    my $del_crrx = $this->{del_crrx};
    my $del_crry = $this->{del_crry};
    $sox[0] = $$txarr[0]->Soy();
    $soy[0] = $$tyarr[0]->Soy();
    while($ig < $ndat && $ix < $nx && $iy < $ny){
	if($soy[0] < $sox[0]){
	    $ig++ while($sox[0] >$$tm[$ig]->Soy() && $ig < $ndat);
	}else{
	    $ig++ while($soy[0] >$$tm[$ig]->Soy() && $ig < $ndat);
	}
	my $sog = $$tm[$ig]->Soy();
	$ix++ while( $$txarr[$ix]->Soy() < $sog && $ix < $nx);
	$iy++ while( $$tyarr[$iy]->Soy() < $sog && $iy < $ny);
	@sox = ($$txarr[$ix-1]->Soy(),$$txarr[$ix]->Soy());	
	@soy = ($$tyarr[$iy-1]->Soy(),$$tyarr[$iy]->Soy());
	
	my @tmp_dry = ($$atmxarr[0][$ix-1], $$atmxarr[0][$ix]);
	my @tmp_wet = ($$atmxarr[1][$ix-1], $$atmxarr[1][$ix]);
	my @tmpx = (\@tmp_dry, \@tmp_wet);
	my @atmx = &Intrp($sog, \@sox, \@tmpx);
	
	@tmp_dry = ($$atmyarr[0][$iy-1], $$atmyarr[0][$iy]);
	@tmp_wet = ($$atmyarr[1][$iy-1], $$atmyarr[1][$iy]);
	my @tmpy = (\@tmp_dry, \@tmp_wet);
	my @atmy = &Intrp($sog, \@soy, \@tmpy);

	$atmx[0] *= $atm_fnc->Fm_Dry_Moran($elx[$ig]);
	$atmx[1] *= $atm_fnc->Fm_Wet_Moran($elx[$ig]);
	$atmy[0] *= $atm_fnc->Fm_Dry_Moran($ely[$ig]);
	$atmy[1] *= $atm_fnc->Fm_Wet_Moran($ely[$ig]);
	$$del_crrx[$ig] = $atmx[0] +  $atmx[1];
	$$del_crry[$ig] = $atmy[0] +  $atmy[1];
	$del_crr[$ig] = $$del_crrx[$ig] - $$del_crry[$ig];
	$ig++;
    }

    $this->{del_crr} = \@del_crr;
    $this->{del_crrx} = $del_crrx;
    $this->{del_crry} = $del_crry;
}

sub Set_crrxy($\@\@\@){
    my ($this, $tarr,$crrx, $crry) = @_;
    my (@del_crrx, @del_crry);
    my $ndat = $this->{ndat};
    my $tm = $this->{time};
    my $cnt=0;
    for(my $i=0; $i<$ndat; $i++){
	$cnt++ while($$tm[$i]->Soy() > $$tarr[$cnt]->Soy());
	$del_crrx[$i] = $$crrx[$cnt];
	$del_crry[$i] = $$crry[$cnt];
    }

    $this->{del_crrx} = \@del_crrx;
    $this->{del_crry} = \@del_crry;
}
sub Make_correction2(\@\@\@\@){
    ($this,$txarr, $tphx, $tyarr, $tphy) = @_;
    
    my $nx = @$txarr;
    my $ny = @$tyarr;
    my $ndat = $this->{ndat};
    my $elx = $this->{elx};    
    my $ely = $this->{ely};
    my $tm = $this->{time};
    my $del_crrx = $this->{del_crrx};
    my $del_crry = $this->{del_crry};

    my ($ig, $ix, $iy) = (0,0,0);
    my (@sox, @soy);
    $ix =$iy = 1;
    my $atm_fnc = new Atm_Moran;
    my  @del_crr;
    $sox[0] = $$txarr[0]->Soy();
    $soy[0] = $$tyarr[0]->Soy();
    while($ig < $ndat && $ix < $nx && $iy < $ny){
	if($soy[0] < $sox[0]){
	    $ig++ while($sox[0] >$$tm[$ig]->Soy() && $ig < $ndat);
	}else{
	    $ig++ while($soy[0] >$$tm[$ig]->Soy() && $ig < $ndat);
	}
	my $sog = $$tm[$ig]->Soy();
	$ix++ while( $$txarr[$ix]->Soy() < $sog && $ix < $nx-1);
	$iy++ while( $$tyarr[$iy]->Soy() < $sog && $iy < $ny-1);
	@sox = ($$txarr[$ix-1]->Soy(),$$txarr[$ix]->Soy());	
	@soy = ($$tyarr[$iy-1]->Soy(),$$tyarr[$iy]->Soy());
	
	my (@tphx_r, @tphy_r);
	for($i=0; $i<3; $i++){
	    my @tmp_arr = ($$tphx[$i][$ix-1], $$tphx[$i][$ix]);
	    $tphx_r[$i] = &Intrp0($sog, \@sox, \@tmp_arr);
	}
	for($i=0; $i<3; $i++){
	    my @tmp_arr = ($$tphy[$i][$iy-1], $$tphy[$i][$iy]);
	    $tphy_r[$i] = &Intrp0($sog, \@soy, \@tmp_arr);
	}
	
	my @atmxz = $atm_fnc->Excess_Chao_del(@tphx_r);
	my @atmyz = $atm_fnc->Excess_Chao_del(@tphy_r);


	$atmx[0] = $atmxz[0] * $atm_fnc->Fm_Dry_Moran($$elx[$ig]);
	$atmx[1] = $atmxz[1] * $atm_fnc->Fm_Wet_Moran($$elx[$ig]);
	$atmy[0] = $atmyz[0] * $atm_fnc->Fm_Dry_Moran($$ely[$ig]);
	$atmy[1] = $atmyz[1] * $atm_fnc->Fm_Wet_Moran($$ely[$ig]);
	$$del_crrx[$ig] = $atmx[0] +  $atmx[1];
	$$del_crry[$ig] = $atmy[0] +  $atmy[1];
	$del_crr[$ig] = $$del_crrx[$ig] - $$del_crry[$ig];
	$ig++;
    }
    $this->{del_crr} = \@del_crr;
    $ig;
}

# sub Make_correction3($\@\@){
#     my ($this, $tarr, $darr) = @_;

#     my $nx = @$tarr;
#     my $ndat = $this->{ndat};
#     my $tm = $this->{time};
#     my $del = $this->{del};
#     my @del_crr;

#     my ($ig, $ix) = (0,0,0);
#     my @soy;
#     $ix =1;

#     $soy[0] = $$tarr[0]->Soy();
#     while($ig < $ndat && $ix < $nx ){
# 	$ig++ while($ig < $ndat && $soy[0] >$$tm[$ig]->Soy() );
# 	my $sog = $$tm[$ig]->Soy();
# 	$ix++ while( $ix < $nx-1 && $$tarr[$ix]->Soy() < $sog );
# 	$soy[1] =  $$tarr[$ix]->Soy();
# 	@yar = ($$darr[$ix-1], $$darr[$ix]); 
# 	my $dy = $yar[1] - $yar[0];
# 	my $dt = $soy[1] - $soy[0];	
# 	my $dt1 = $$tm[$ig]->Soy() - $soy[0];
# 	my $y1 = $dy/$dt *$dt1 + $yar[0];
# 	$del_crr[$ig] = $$del[$ig] - $y1;
# 	shift(@yar);
# 	shift(@soy);
# 	$ig++;
#     }
#     $this->{del_crr} = \@del_crr;
# }

sub Make_correction_just($\@\@;\@){
    my ($this, $tarr, $darr,$aerr) = @_;

    my $nx = @$tarr;
    my $ndat = $this->{ndat};
    my $tm = $this->{time};

    my $derr = $this->{derr};
    my @del_crr;

    if( $nx  < $ndat){
	print STDERR "Error: Data number mismatched in Make_correction_just()\n";
	print STDERR "nx =$nx, ndat = $ndat\n";
	exit(1);
    }
    my ($ix, $iy) = (0,0);
    for($ix =0; $ix < $ndat; $ix++){
	$iy++ while($$tm[$ix]->Soy()  >  $$tarr[$iy]->Soy());
	if( $$tm[$ix]->Soy()  != $$tarr[$iy]->Soy()){
	    print STDERR "Error: Data Epoch mismatched in Make_correction_just()\n";
	    printf STDERR "soy[$ix] = %f, tarr-soy = %f\n",
	    $$tm[$ix]->Soy(),$$tarr[$iy]->Soy();
	    exit(1);
	}
	$del_crr[$ix] = -$$darr[$iy];
	if(defined($aerr)){
	    $$derr[$ix] = sqrt($$derr[$ix]*$$derr[$ix] + $$aerr[$iy]*$$aerr[$iy]);
	}
    }
    $this->{del_crr} = \@del_crr;

}

sub Read($$){
    my ($this, $file) = @_;
    my     (@tm, @del, @src, @ambf, @amp, @derr, @snr, @elx, @ely);
    my (@atmcrr, @ioncrr);
    open(IN,$file)  || die "Cannot open file $file.\n";
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	my @terms = split(/\s+/);
	if(@terms < 11){
	    print STDERR "Error: format may be wrong\n";
	    print STDERR "line = $_";
	    next;
	}
	my $tm0 = new Time_lib;
	$tm0->Set_time_strydhms($terms[0], $terms[1]);
	$tm[$cnt] = $tm0;
	$del[$cnt] = $terms[3];
	$src[$cnt] = $terms[4];
	$ambf[$cnt] = $terms[5];
	$amp[$cnt] = $terms[6];
	$derr[$cnt] = $terms[7];
	$snr[$cnt] = $terms[8];
	$elx[$cnt] = $terms[9];
	$ely[$cnt] = $terms[10];
	$atmcrr[$cnt] = $terms[11] if(defined($terms[11]));
	$ioncrr[$cnt] = $terms[12] if(defined($terms[12]));
	$cnt++;
    }
    close(IN);
    $this->{ndat} = $cnt;
    $this->{time} = \@tm;
    $this->{del} = \@del;
    $this->{src} = \@src;
    $this->{ambf} = \@ambf;
    $this->{amp} = \@amp;
    $this->{derr} = \@derr;
    $this->{snr} = \@snr;
    $this->{elx} = \@elx;
    $this->{ely} = \@ely;
    $this->{atmc} = \@atmcrr;
    $this->{ionc} = \@ioncrr;
    return $cnt;
}

1;
