package Histgram;
use Exporter;
use Carp;
use Math::Round qw (nearest);

@ISA = qw(Exporter);

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

## Set Max, Min, Step
sub Set_maxmin($$$$){
    my $pkg = shift;
    my $max = shift;    
    my $min = shift;
    if($max > $min){
	$pkg->{min} = $min;
	$pkg->{max} = $max;
    }else{
	$pkg->{min} = $max;
	$pkg->{max} = $min;
    }
    $pkg->{step} = shift;

}

sub Comp($@){
    my ($pkg, @yarr) = @_;
    unless(defined($pkg->{min}) && 
	   defined($pkg->{max}) && 
	   defined($pkg->{step}) ){
	print "E Histgram::Set_maxmin() must be before Comp(). \n";
	return -1;
    }
    my $max = $pkg->{max};
    my $min = $pkg->{min};
    my $step = $pkg->{step};
    my $range = $max - $min;
    my $dstep = $range/$step;
    my $nstp = int($dstep) +1;
    my $ndat = @yarr;
#    $nstep++ if($dstep > $nstep);
    my (@hist, @xarr);
    for(my $i=0; $i<$nstp; $i++){
	$hist[$i] = 0; 
	$xarr[$i] = $min + $i*$step;
    }
    foreach $d (@yarr){
	if ($d < $min+ 0.5*$step){ 
	    $hist[0]++;
	}elsif ($d > $max - 0.5*$step){ 
	    $hist[$nstp-1]++;
	}else{ 
	    my $x = $d - $min; 
	    my $i = nearest(1, $x/$step); 
	    $hist[$i]++;
	}
    }
    $pkg->{hist} = \@hist;
    $pkg->{xhist} = \@xarr;
    $pkg->{nstp} = $nstp;
    my @rhist;
    for($i=0; $i < @hist; $i++){ 
	$rhist[$i] =$hist[$i]/$ndat * 100.;   
	$rhist[$i] = 1.e-30 if($hist[$i] == 0);
    }
    $pkg->{rhist} = \@rhist;
    return @hist;
}

sub StepArr($){
    my $pkg = shift;
    return @{$pkg->{xhist}};
}
sub HistArr($){
    my $pkg = shift;
    return @{$pkg->{hist}};
}

sub NormalHistArr($){
    my $pkg = shift;
    return @{$pkg->{rhist}};
}

sub Npt($){
    my $pkg = shift;
    return $pkg->{nstp};
}

1;
