# @Version: $Id: Horizon.pm 48 2014-11-30 03:51:32Z sekido $
#

package Horizon;
use Exporter;
use Time_lib;
@ISA = qw(Exporter);
@EXPORT = qw(Read_line Xyz Set_files XYZ_out Read_linei);

BEGIN{
    $AU = 149597870.691; # (km)
    %Month = ('Jan' =>1, 'Feb' =>2, 'Mar' =>3, 'Apr' =>4,
	      'May' =>5, 'Jun' =>6, 'Jul' =>7, 'Aug' =>8,
	      'Sep' =>9, 'Oct' => 10, 'Nov' =>11, 'Dec' =>12);
    $PI = atan2(1.,1.)*4.;
};

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_files ($$){
    my ($this, $infile) = @_;
    $this->{horizn_file} = $infile;
    my $p = caller;
    my $in = $p . "::" . IN;
    open($in, $infile) || die "Cannot open file ($infile)\n";
    $this->{in} = $in;

};


sub XYZ_out($;$){
    my ($this,$fd) = @_;
    my $out = $fd; 
    
    if( defined($fd)){
	my $p = caller;	
	$out = $p . "::" . $fd;
    }else{
	$out = STDOUT;
    }
    my $t1 = $this->{time};
    my $xyz = $this->{xyz};
    if( defined($fd)){$t1->Print_fmt1($out);}
    else{    $t1->Print_fmt1();}
    printf $out " %24.17e %24.17e %24.17e %10.3e %10.3e %10.3e\n",
    $$xyz[0], $$xyz[1], $$xyz[2], 0.,0.,0. ;

}

sub Read_line($) {
    my $this = shift;
    my $infile = $this->{horizn_file};
    my $in = $this->{in};
    
    die "Error IN is not defined\n" unless( defined($in));
    
    my $flag=1;
    while($flag == 1){
	if(eof($in)){
	    $flag=-1;
	    close($in);
	    next;
	}
	my $line = <$in>;
	my @terms = split(/\s+/, $line);
	if(@terms < 27){ 
	    # print "Data format is worng \n"; 
	    next;}
	my $ist=0;
	$ist++ if($terms[4] =~/[A-Z,a-z,\*]+/);

	my @ymd = split(/-/,$terms[1]);
	my @hm = split(/:/,$terms[2]);
	my $t1 = new Time_lib;
	$t1->Set_time_ymd($ymd[0], $Month{$ymd[1]}, $ymd[2], $hm[0], $hm[1], 0);
	my @ra = ($terms[$ist + 4],$terms[$ist + 5],$terms[$ist+6]);
	my @dec = ($terms[$ist+7],$terms[$ist+8],$terms[$ist+9]);
	my $r = $terms[$ist+25] * $AU;
	my $dr = $terms[$ist +26];
	my @xyz;
	my $ra_rad = (($ra[2]/60. + $ra[1])/60. + $ra[0])/12. * $PI;
	my $sgn = $dec[0] > 0 ? 1 : -1;
	my $dec_rad = (($dec[2]/60. + $dec[1])/60. + abs($dec[0]))/180. * $PI * $sgn;
	$xyz[0] = $r * cos($ra_rad) * cos($dec_rad);
	$xyz[1] = $r * sin($ra_rad) * cos($dec_rad);
	$xyz[2] = $r * sin($dec_rad);
	
	$this->{ra} = \@ra;
	$this->{dec} = \@dec;
	$this->{r} = $r;     # (km) 
	$this->{dr} = $dr;   # (km/sec)/:
	$this->{xyz} = \@xyz;
	$this->{time} = $t1;
	$flag=0;
    }

    return ($flag);
 }


1;

