package Ion_fmt;
 # EXpected data format is 
 # # REF FREQ = 8.408 (GHz)
 #  1: 1352-104 2005/308 02:06:27.000   OT -7.3666e-12 3.5051e-11 +8.4088e-16 1.0837e-13 
 # where Srcname Time(UTC)  Baseid del(sec) derr, rate(s/s) raterr (s/s)
# @Version: $Id: Ion_fmt.pm 48 2014-11-30 03:51:32Z sekido $
#

use Exporter;

use Time_lib;
@ISA = qw(Exporter);

#@EXPORT = qw(Read);

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Ndat($){
    my  $this = shift();
    $this->{ndat};
}

sub Darr($){
    my $this = shift;
    return $this->{del};
}

sub Tarr($){
    my $this = shift;
    return $this->{tarr};
}

sub DEarr($){
    my $this = shift;
    return $this->{derr};
}

sub Del($$){
    my ($this,$idat) = @_;
    my $del = $this->{del};
    my $ndat = $this->{ndat};

    if( $idat <0 || $idat >= $ndat){
	print STDERR "Error: DEL(idat=$idat) is out of range (< $ndat)\n";
	exit(1);
    }
    return $$del[$idat];
}

sub Derr($$){
    my ($this,$idat) = @_;
    my $derr = $this->{derr};
    my $ndat = $this->{ndat};

    if( $idat <0 || $idat >= $ndat){
	print STDERR "Error: DERR(idat=$idat) is out of range (< $ndat)\n";
	exit(1);
    }
    return $$derr[$idat];
}

sub Rat($$){
    my ($this,$idat) = @_;
    my $rat = $this->{rat};
    my $ndat = $this->{ndat};

    if( $idat <0 || $idat >= $ndat){
	print STDERR "Error: RAT(idat=$idat) is out of range (< $ndat)\n";
	exit(1);
    }
    return $$rat[$idat];
}

sub Read($$){
    my ($this, $infile) = @_;
    
    my (@src, @tarr, @base, @del, @derr, @rat, @raterr);
    open(IN, $infile) || die "Error: Cannot open file $infile\n";
    my $icnt=0;
    while(<IN>){
	next if(/^\#/);
	/\s*/;
	my @terms = split(/\s+/, $'); #')
	if( @terms < 9){
	    print STDERR "Warning:data format of ionfile is wrong \n";
	    print STDERR " line= $_\n";
	    next;
	}
	$src[$icnt] = $terms[1];
	my $t1 = new Time_lib;
	$t1 ->Set_time_strydhms($terms[2], $terms[3]);
	$tarr[$icnt] = $t1;
	$base[$icnt] = $terms[4];
	$del[$icnt] = $terms[5];
	$derr[$icnt] = $terms[6];
	$rat[$icnt] = $terms[7];
	$raterr[$icnt] = $terms[8];
	$icnt++;
    }
    close(IN);
    $this->{tarr} = \@tarr;
    $this->{base} = \@base;
    $this->{del} = \@del;
    $this->{derr} = \@derr;
    $this->{rat} = \@rat;
    $this->{raterr} = \@raterr;
    $this->{ndat} = $icnt;
    $icnt;
}

1;
