## Metrorogical data reading module.
## This data is taken at roof of 2-goukan of NICT.
## Data shold be available at http://jjyhwtr/D140506.txt
package JJYMet_dat;
use Exporter;
use Carp;

use Time_lib;

@ISA = qw(Exporter);

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$){
    my $pkg = shift;
    my $infile = shift;
    
    unless(open(IN,$infile)){
	print STDERR "E Failed to Met_dat::Read() \n";
	return -1;
    }
    my (@t,@p,@h, @tarr);

    my $icnt = 0;
    my $tm_prev;
    while(<IN>){
	next if(/Date/);
	my @ymdhms = ( substr($_,0,4), substr($_,5,2), substr($_,8,2),
			substr($_,11,2),substr($_,14,2),00 );
	if( substr($_,57,1) !=1 || substr($_,65,1) !=1 || substr($_,81,1) !=1 ){
	    printf "W data at %04d/%02d/%02d-%02d:%02d:%02d is invalid\n",@ymdhms; 
	    next;
	}

	$tarr[$icnt] = new Time_lib;
	$tarr[$icnt]->Set_time_ymd(@ymdhms);
	$tarr[$icnt] -= 9 * 3600;  # Because Time tag is JST(+9) 
	$t[$icnt] = substr($_,61,3) * 0.1;
	$p[$icnt] = substr($_,82,6) * 0.1;
	$h[$icnt] = substr($_,69,3) ;
	$t[$icnt] *= substr($_,58,1) eq '+' ? 1 : -1;
	$icnt++;
    }
    $pkg->{temp}  = \@t;
    $pkg->{pres}  = \@p;
    $pkg->{humid} = \@h;
    $pkg->{time}  = \@tarr;
    close(IN);
    return ($#t +1);
}

sub Temp($){
    my $pkg = shift;
    return @{$pkg->{temp}};
}

sub Pres($){
    my $pkg = shift;
    return @{$pkg->{pres}};
}

sub Humid($){
    my $pkg = shift;
    return @{$pkg->{humid}};
}

sub Tarr($){
    my $pkg = shift;
    return @{$pkg->{time}};
}

1;
