# @Version: $Id: K5_apr_fmt.pm 48 2014-11-30 03:51:32Z sekido $
#
package K5_apr_fmt;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

END{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$){
    my ($pkg, $fname) = @_;

    $pkg->{fname} = $fname;
    unless(open(IN,$fname) ){
	print STDERR "Read failed in file=$fname \n";
	return -1;
    }
    # mode 1: expcode, 2:$OBS_NUMBER, 3:STATION1, 4:XYZ-STATION1, 5:STATION2,
    # 6:XYZ-STATION2, 7:$BASEID, 8:FRQ_GRP, 9:FREQENCY 10:PCAL_FREQ, 11:CLOCK
    # 12: SOURCE, 13: RA, 14:Dec, 15:$EPOCH,16:$GHA,17:$EOP,18:$START,19:$STOP,
    # 20: $APRIORI, 21: $END
    my $mode =0;
    while(<IN>){
	next if(/^\*/);
	if(/\$EXPCODE/){$mode =1; next;}
	elsif(/\$OBS_NUMBER/){$mode =2; next;}
	elsif(/\$STATION1/){$mode =3; next;}
	elsif(/\$XYZ-STATION1/){$mode =4; next;}
	elsif(/\$STATION2/){$mode =5; next;}
	elsif(/\$XYZ-STATION2/){$mode =6; next;}
	elsif(/\$BASEID/){$mode =7; next;}
	elsif(/\$FRQ_GRP/){$mode =8; next;}
	elsif(/\$FREQENCY/){$mode =9; next;}
	elsif(/\$PCAL_FREQ/){$mode =10; next;}
	elsif(/\$CLOCK/){$mode =11; next;}
	elsif(/\$SOURCE/){$mode =12; next;}
	elsif(/\$RA/){$mode =13; next;}
	elsif(/\$Dec/){$mode =14; next;}
	elsif(/\$EPOCH/){$mode =15; next;}
	elsif(/\$GHA/){$mode =16; next;}
	elsif(/\$EOP/){$mode =17; next;}
	elsif(/\$START/){$mode =18; next;}
	elsif(/\$STOP/){$mode =19; next;}
	elsif(/\$APRIORI/){$mode =20; next;}
	elsif(/\$END/){$mode =21; last;}

	if($mode == 1){  ## Expcode 
	    $pkg->{expcode} = $1 if(/\S+/); next;
	}elsif($mode == 2){ ## OBS_NUMBER
	    $pkg->{obs_num} = $1 if(/\d+/); next;
	}elsif($mode == 3){ ## Station1
	    my @terms = split(/\s+/); 
	    ($pkg->{Xst_name}, $pkg->{Xst_file}) = @terms if(@terms > 1); next;
	}elsif($mode == 4){ ## XYZ station1
	    my @terms = split(/\s+/); 
	    $pkg->{Xst_xyz} = \@terms if(@terms ==3 ); 
	    next;
	}elsif($mode == 5){ ## Station2
	    my @terms = split(/\s+/); 
	    ($pkg->{Yst_name}, $pkg->{Yst_file}) = @terms if(@terms > 1); next;
	}elsif($mode == 6){ ## XYZ station2
	    my @terms = split(/\s+/); 
	    $pkg->{Yst_xyz} = \@terms if(@terms ==3 ); next;
	}elsif($mode ==7){
	    next;
	}elsif($mode ==8){
	    next;
	}
    }
    close(IN);
}

sub Yst_file($){
    my $pkg = shift;
    $pkg->{Yst_file};
}
sub Xst_file($){
    my $pkg = shift;
    $pkg->{Xst_file};
}

1;
