# @Version: $Id: K5_fname.pm 48 2014-11-30 03:51:32Z sekido $
#
package K5_fname;

#use Exporter;
#@ISA = qw(Exporter);

#@EXPORT = qw(Soy Sod Fsize Set_str);

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Ret_fname($$){
    my ($pkg,$onum) = @_;
    if($onum ==2){
	unless(defined($pkg->{stid})){
	    print STDERR "Error: stid is not defined\n";
	    exit(1);
	}
	unless(defined($pkg->{doy}) && defined($pkg->{hh}) && 
	       defined($pkg->{mm}) && defined($pkg->{ss}) ){
	    print STDERR "Error: doy-hh:mm:ss is not defined.\n";
	    exit(1);
	}
	unless(defined($pkg->{grp}) ){
	    print STDERR "Error: grp id is not defined.\n";
	    exit(1);
	}
	my $fname = sprintf "%s%03d%02d%02d%02d%s.dat",
	$pkg->{stid},$pkg->{doy},$pkg->{hh},$pkg->{mm},$pkg->{ss},
	$pkg->{grp};
    }
    
}

sub Set_fname($$){
    my ($pkg,$str) = @_;
    my @fname_ptn;
    my $chars ="[A-Z,a-z,0-9]+";
    my $cgru = "[-_]";
    
    $fname_ptn[0]= "(\\S)(\\d{3})(\\d{6})(\\S?).dat\$";
    $fname_ptn[1]= "(\\S)(\\d{3})(\\d\\d)(\\d\\d)(\\d\\d)(\\S).dat";
    $fname_ptn[2]= "($chars)" . $cgru . $chars . "(\\S)" . $cgru .
	"\\d{3}-\\d{4}\\S?" . $cgru .
	"(\\d{4})(\\d{3})(\\d\\d)(\\d\\d)(\\d\\d).k5";
    if( $str =~/$fname_ptn[0]/){
	$pkg->{type} = 1;
	my @gmt = gmtime();
	$pkg->{year} = $gmt[5]+1900;
	$pkg->{doy} = $2;
	$pkg->{stid} = $1;
	$pkg->{snum} = $3;
	$pkg->{grp} = $4 if(defined($4));
	return 1; 
    }
    
    if( $str =~/$fname_ptn[1]/){
	$pkg->{type} = 2;
	my @gmt = gmtime();
	$pkg->{year} = $gmt[5]+1900;
	$pkg->{doy} = $2;
	$pkg->{stid} = $1;
	$pkg->{hh} = $3;
	$pkg->{mm} = $4;
	$pkg->{ss} = $5;
	$pkg->{grp} = $6;
	return 2; 
    }
    
   if( $str =~/$fname_ptn[2]/){
       my @gpid = qw( a b c d);
       $pkg->{type} = 3;
       
	$pkg->{grp} = $gpid[$2-1];
       
       $pkg->{year} = $3;
       $pkg->{doy} = $4;
       $pkg->{hh} = $5;
       $pkg->{mm} = $6;
       $pkg->{ss} = $7;
       return 3; 
   }
    
    return -1;

}

sub Set_stid($$){
    my ($pkg,$str) = @_;
    $pkg->{stid} = $str;
}

sub Set_hms($$$$){
    my ($pkg,$h, $m, $s) = @_;
    $pkg->{hh} = $h;
    $pkg->{mm} = $m;
    $pkg->{ss} = $s;
}

sub Set_snum($$){
    my ($pkg,$snum) = @_;
    $pkg->{snum} = $snum;
}

1;


