## Metrorogical data reading module.
## This data is taken at roof of 2-goukan of NICT.
## Data shold be available at http://piaf.nict.go.jp/qzs/met_data/bd2s/
# @Version: $Id: Met_dat.pm 48 2014-11-30 03:51:32Z sekido $
#

package Met_dat;
use Exporter;
use Carp;

use Time_lib;

@ISA = qw(Exporter);

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$$){
    my $pkg = shift;
    my $infile = shift;
    my $t0 = shift;
    
    unless(open(IN,$infile)){
	print STDERR "E Failed to Met_dat::Read() \n";
	return -1;
    }
    my (@t,@p,@h, @tarr);
    my $yy = $t0->Year();
    my $doy = $t0->Doy();

    my $icnt = 0;
    my $tm_prev;
    while(<IN>){
	next if(/^\#/);
	my @terms = split(/\s+/);
	my @hm = split(/:/,$terms[0]);
	$tarr[$icnt] = new Time_lib;
	$tarr[$icnt]->Set_time_ydhms($yy,$doy,$hm[0],$hm[1],0);
	if($icnt > 0){
	    my $tdif = $tarr[$icnt] - $tm_prev ; 
	    if($tdif < -3600){
		$doy ++;
		$tarr[$icnt]->Set_time_ydhms($yy,$doy,$hm[0],$hm[1],0);
	    }
	}
	$tm_prev = $tarr[$icnt];

	$t[$icnt] = $terms[1];
	$p[$icnt] = $terms[2];
	$h[$icnt] = $terms[3];
	$icnt++;
    }
    $pkg->{temp}  = \@t;
    $pkg->{pres}  = \@p;
    $pkg->{humid} = \@h;
    $pkg->{time}  = \@tarr;
    close(IN);
    return ($#t +1);
}

sub Temp($){
    my $pkg = shift;
    return @{$pkg->{temp}};
}

sub Pres($){
    my $pkg = shift;
    return @{$pkg->{pres}};
}

sub Humid($){
    my $pkg = shift;
    return @{$pkg->{humid}};
}

sub Tarr($){
    my $pkg = shift;
    return @{$pkg->{time}};
}

1;
