# @Version: $Id: Mjd.pm 48 2014-11-30 03:51:32Z sekido $
#
package Mjd;
use Exporter;
@ISA = qw(Exporter);

@EXPORT =qw(doy mjd mjd2);

BEGIN {
}

sub doy ($$$)
{
    my ($yy, $mm, $dd) = @_;
    unless( defined($yy) && defined($mm) && defined($dd)){
	print STDERR "Error: yy($yy) mm($mm) dd($dd) are not defined in Mjd() \n";
	exit(0);
    }
    
    %Ndoy = ( 1 => '0',   '01' => '0',   
	      2 => '31',   '02' => '31',
	      3 => '59', '03' => '59', 
	      4 => '90', '04' => '90',
	      5 => '120','05' => '120',
	      6 => '151','06' => '151',
	      7 => '181', '07' => '181', 
	      8 => '212', '08' => '212',
	      9 => '243', '09' => '243', 
	      10 => '273',
	      11 => '304', 12 => '334'
	      ) ;
    
    $yy += ($yy > 50 ? 1900 : 2000) if( $yy < 100); 
    
    my $doy = $Ndoy{$mm+0} + $dd;
    $doy ++ if ( $mm > 2 && (($yy % 4 == 0 && $yy % 100 != 0) || $yy % 400 == 0)); 

    $doy;
}


sub mjd ($$$)
{
##  (yy,mm,dd)
## /* EXMJD ̌vZ  */
## /* }CRFu   */
  my ($yy,$mm,$dd) = @_;
  
  unless(defined($yy) && defined($mm) && defined($dd)){
      print STDERR "yy($yy) mm($mm) dd($dd) are not defined in mjd()\n";
      return(0);
  }
  if( $yy < 1900){
      $yy += $yy <50 ? 2000 : 1900;
  }

  if ( $mm == 1 || $mm == 2) {
       $yy -=1;
       $mm += 12;
      }

    $work1 = int(365.25 * $yy) + int($yy/400.0) - int($yy/100.0)
	  + int(30.59 * ($mm - 2.0)) + int($dd) - 678912;

    $work2 = int(365.25 * 1582.0) + int(1582.0/400.0) - int(1582.0/100.0)
	  + int(30.59 * (10.0 - 2.0)) + 4.0 - 678912;

    if( $work1 < $work2 ){ ## /* ݃OSIł邪A1582/10/4 ܂ł
			   ## EXgĂB*/
	  if( $yy > 0.0) {  ## /*  I */
	      $work5 = int(365.25*$yy) + int(30.59*($mm- 2)) + $dd - 678914;}
	   else {           ## /* IO  */
	      $work5 = int(365.25*$yy) + int(30.59*($mm- 2)) + $dd - 678915;}
     }
     else{
	    $work5 = int(365.25*$yy) + int($yy/400.) - int($yy/100.) 
	           + int(30.59*($mm- 2)) + $dd - 678912;
	}
      $MJD = $work5;
      $JD = $MJD + 2400000.5;
      $MJD;
}

sub mjd2 ($$;\$)
{
##  (yy,doy,JD)
## /* EXMJD ̌vZ  */
## /* }CRFu   */
    my ($yy,$doy, $JD) = @_;
  
    my   $mm = 1;
    my   $dd = 1;
    
    if ( $mm == 1 || $mm == 2) {
	$yy -=1;
	$mm += 12;
    }

    my  $work1 = int(365.25 * $yy) + int($yy/400.0) - int($yy/100.0)
	+ int(30.59 * ($mm - 2.0)) + int($dd) - 678912;

    my  $work2 = int(365.25 * 1582.0) + int(1582.0/400.0) - int(1582.0/100.0)
	+ int(30.59 * (10.0 - 2.0)) + 4.0 - 678912;

    if( $work1 < $work2 ){ ## /* ݃OSIł邪A1582/10/4 ܂ł
	## EXgĂB*/
	if( $yy > 0.0) {  ## /*  I */
	    my $work5 = int(365.25*$yy) + int(30.59*($mm- 2)) + $dd - 678914;}
	else {           ## /* IO  */
	    my $work5 = int(365.25*$yy) + int(30.59*($mm- 2)) + $dd - 678915;}
    }
    else{
	$work5 = int(365.25*$yy) + int($yy/400.) - int($yy/100.) 
	    + int(30.59*($mm- 2)) + $dd - 678912;
    }
    my  $MJD = $work5 +$doy-1;
    $$JD = $MJD + 2400000.5;
    $MJD;
}

1;
