# @Version: $Id: Model_poly.pm 80 2016-01-14 10:45:40Z sekido $
#
package Model;
use Exporter;
use Carp;

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

##
sub Read1($$){ # Reading 1st order model
    my $pkg = shift;
    my $infile = shift;
    unless(open(IN, $infile)){
	print STDERR "Err: Failed to open model-file [$infile] \n";
	return -1;
    }
    my $mjd0 ;
    my @cff;
    my $step =0;
    while(<IN>){
	next if(/^\#/);
	next unless(/\S+/);
	my @tms = split(/\s+/);
#	if($tms[0] =~/mjd0=\s+(\S+)/){
#	    $mjd0 = $tms[1];
	if(/\$MJD_EPOCH/){
	    close(IN);
	    $pkg->Read2($infile);
	    return 1;
	}elsif(/mjd0=\s*(\S+)/){
	    $mjd0 = $1;
	    $step=1;
#	}elsif($tms[0] =~/mjd0=(\S+)/){
	}elsif(/mjd0=(\S+)/){
	    $mjd0 =$1;
	    $step=1;
	}elsif($step == 1 && @tms <10){
	    @cff = @tms;
	    last;
	}
    }
    close(IN);

    $pkg->{cff} = \@cff;
    $pkg->{mjd0} = $mjd0;
}

# Use $EPOCH_MJD, $CFF label for each data line
sub Read2($$){ # Reading any order model
    my $pkg = shift;
    my $infile = shift;
    unless(open(IN, $infile)){
	print STDERR "Err: Failed to open model-file [$infile] \n";
	return -1;
    }
    my $mjd0 ;
    my @cff;
    while(<IN>){
	next if(/^\#/);
	my @tms = split(/\s+/);
	my $label = shift(@tms);
	if($label =~/\$EPOCH_MJD/  || $label =~/\$MJD_EPOCH/){
	    $mjd0 = shift(@tms);
	}elsif($label =~/\$CFF/){
#	    $mjd0 =$1;
#	}elsif(@tms <10){
	    @cff = @tms;
	    last;
	}
    }
    close(IN);

    $pkg->{cff} = \@cff;
    $pkg->{mjd0} = $mjd0;
}

sub Cff($){
    my $pkg = shift;
    return $pkg->{cff};
}

sub Mjd0($){
    my $pkg = shift;
    return $pkg->{mjd0};
}

sub Calc($$){
    my $pkg = shift;
    my $x = shift;
    my @cff = @{$pkg->{cff}};
    
    $x -= $pkg->{mjd0};

    my $m=0;
    for(my $i=0; $i<@cff; $i++){
	$m = $m * $x + $cff[$i];
    }
    return $m;
    
}

1;
