#
#  Communication Server module 
#  @Auther: by M.Sekido 
#  @Date:  2007.5.18 
#  @Version: $Id: Obs_com_srv.pm 48 2014-11-30 03:51:32Z sekido $
#
#
#
package Obs_com_srv;
use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_srv_port($$){
    my ($pkg,$port) = @_;
    $pkg->{port}=$port;
}

sub Open_srvSocket($){
    my $pkg = shift;
    my $listening_socket = IO::Socket::INET->new(LocalPort => $pkg->{port},
						 Listen    => SOMAXCONN,
						 Proto     => 'tcp',
						 Reuse     => 1 );
    unless(defined($listening_socket)){
	print STDERR "Error in creating socket\n";
	printf STDERR " port: %d may be already in use\n", $pkg->{port};
	exit(1); 
    }
    $pkg->{srv_sock} = $listening_socket;
}

sub Wait_Oreport($){
    my $pkg = shift;
    
    $obs_entry = $pkg->{obs_entry};
    my $entry;
    
#    while (1){

    printf STDERR " Waiting connection(Observtion Report) at port %d \n",
    $pkg->{port};
    
    my $new_socket = $pkg->{srv_sock}->accept();
    
    my $client_sockaddr = $new_socket->peername();
    my ($client_port,$client_iaddr) = unpack_sockaddr_in($client_sockaddr);
    my $client_hostname = gethostbyaddr($client_iaddr, AF_INET);
    my $client_ip = inet_ntoa($client_iaddr);

    print "Connected: $client_hostname($client_ip) Port: $client_port\n";
    select($new_socket); $|=1; # stop buffering 
    select(STDOUT);
    
    while (<$new_socket>){
	print "Received Message: $_ \n";
	## Expecting message like "2007/138-00:00:00 T a"
	unless(m!Scan:\s*(\d{4}/\d{3}-\d\d:\d\d:\d\d)\s+(\S+)\s+(\S+)!){
	    print STDERR "Warning: message format is unexpected\n";
	    next;
	}
	my $time_str = $1;
	my $stid = $2;
	my $gid = $3;
	$entry= "$time_str:$stid:$gid";
	$obs_entry->{$entry} = 1;
	last;
    }
    $new_socket->close();

    printf STDERR "Connection Close  %d.\n", $pkg->{port};
    print STDERR " Current Oreport Entries are:\n";
    foreach my $e (keys(%{$obs_entry})){
	printf STDERR "$e %d\n", $obs_entry->{$e};
    }
    print STDERR "------------------------------\n";
#    }
    return $entry;
    
}

1;
