# @Version: $Id: Pdel_fmt.pm 48 2014-11-30 03:51:32Z sekido $
#
package Pdel_fmt;
#
# Expected format is 
#2005/323 06:27:03    3C345 8337418571.40000  7.4941e-03 -1.033188568229e-04   1.3e-12 493.8
#2005/323 06:27:05    3C345 8337418571.40000  7.4325e-03 -1.033350547981e-04   1.2e-12 493.8


use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(Read Rrite Tarr Ndat);

# use PGPLOT;
use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;

BEGIN {
    ;
}


sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Ndat($){
    $this = shift;
    $this->{ndat};
}

sub Tdat($$){
    my ($this, $idat) = @_;
    
    ${$this->{tarr}}[$idat];
}

sub Src($$){
  my ($this, $idat) = @_;
    
  ${$this->{src}}[$idat];
}

sub Del($$){
    my ($this, $i) = @_;
    my $ndat = $this->{ndat};
    my $del = $this->{tau};
    if($i >= $ndat || $i < 0){
	print STDERR "Error: Del($i) is out of range (<$ndat)\n";
	exit(1);
    }
    return $$del[$i];
}


sub Read($$){
    my ($this, $infile) = @_;

    open(IN, $infile) || die "Error: Cannot open file $infile \n";
    
    my (@yd, @hms, @tau, @frq, @src, @amp, @derr, @snr, @tarr);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	/\s*/;
	my $line = $'; # '
	my @terms = split(/\s+/,$line );
	if( @terms < 8){
	    print "Error: phdel file format is wrong\n";
	    print "We expect: yd hms mjd tau rambg, nambg, src frq amp err snr\n";
	    print "line= $line \n";
	    exit(1);
	}

	$yd[$cnt] = $terms[0];
	$hms[$cnt] = $terms[1];
	$src[$cnt] = $terms[2];
	$frq[$cnt] = $terms[3];
	$amp[$cnt] = $terms[4];
	$tau[$cnt] = $terms[5];
	$derr[$cnt] = $terms[6];	
	$snr[$cnt] = $terms[7];
	my @tmp1 = split(m!/!,$yd[$cnt]);
	my @tmp2 = split(m!:!,$hms[$cnt]);
	$tarr[$cnt] = new Time_lib;
	$tarr[$cnt]->Set_time_ydhms(@tmp1,@tmp2); 
	$cnt++;
    }
    close(IN);

    $this->{tarr} = \@tarr;
    $this->{tau} = \@tau;
    $this->{frq} = \@frq;
    $this->{src} = \@src;
    $this->{amp} = \@amp;
    $this->{snr} = \@snr;
    $this->{derr} = \@derr;    

    $this->{ndat} = $cnt;

    return($cnt);
}

sub Set_tarr($$){
    my ($this,$arr) = @_;
    $this->{tarr} = $arr;
}

sub Set_tau($$){
    my ($this,$arr) = @_;
    $this->{tau} = $arr;
}
sub Set_snr($$){
    my ($this,$arr) = @_;
    $this->{snr} = $arr;
}
sub Set_derr($$){
    my ($this,$arr) = @_;
    $this->{derr} = $arr;
}
sub Set_frqarr($$){
    my ($this,$arr) = @_;
    $this->{frq} = $arr;
}
sub Set_src($$){
    my ($this,$arr) = @_;
    $this->{src} = $arr;
}
sub Set_amp($$){
    my ($this,$arr) = @_;
    $this->{amp} = $arr;
}
sub Set_rat($$){
    my ($this,$arr) = @_;
    $this->{rat} = $arr;
}
sub Set_rerr($$){
    my ($this,$arr) = @_;
    $this->{rerr} = $arr;
}
sub Set_ndat($){
    my ($this) = @_;
    my $tarr = $this->{tarr};
    my $ndat = @$tarr;
    $this->{ndat} = $ndat;
}


# sub Write($$){
#     my ($this, $outfile) = @_;
#     my $ndat = $this->{ndat};
#     my $tarr = $this->{tarr};
#     my $frq = $this->{frq};
#     my $amp = $this->{amp};
#     my $src = $this->{src};
#     my $tau = $this->{tau};
#     my $amp = $this->{amp};
#     my $derr = $this->{derr};
#     my $snr = $this->{snr};
#     my $rat = $this->{rat};
#     my $rerr = $this->{rerr};

#     open(OUT, ">$outfile") || die "Error: Cannot open file $outfile \n";
#     for(my $i=0; $i < $ndat; $i++){
# 	$$tarr[$i]->Print_fmt1(OUT);
# 	printf OUT " %19.13f %+18.11e %13.7e %6d %8s %15.4f %10.4e %8.2e %6.2f\n",
# 	$$tarr[$i]->Mjd(), $$dtau[$i], $$amb[$i], $$iamb[$i], $$src[$i], 
# 	$$frq[$i], $$amp[$i], $$err[$i], $$snr[$i];

# 	if($i<10){
# 	    $$tarr[$i]->Print_fmt1();
# 	    printf STDOUT " %13f %+18.11e %13.7e %6d %8s %15.4f %10.4e %8.2e %6.2f\n",
# 	    $$tarr[$i]->Mjd(), $$dtau[$i], $$amb[$i], $$iamb[$i], $$src[$i], 
# 	    $$frq[$i], $$amp[$i], $$err[$i], $$snr[$i];
# 	}

#     }
#     close(OUT);
    
# }

# ## Write L rate & rerr
# sub Write_ext1($$){
#     my ($this, $outfile) = @_;
#     my $ndat = $this->{ndat};
#     my $tarr = $this->{tarr};
#     my $mjd = $this->{mjd};
#     my $frq = $this->{frq};
#     my $amb = $this->{amb};
#     my $iamb = $this->{iamb};
#     my $src = $this->{src};
#     my $dtau = $this->{dtau};
#     my $amp = $this->{amp};
#     my $err = $this->{err};
#     my $snr = $this->{snr};
#     my $rat = $this->{rat};
#     my $rerr = $this->{rerr};

#     open(OUT, ">$outfile") || die "Error: Cannot open file $outfile \n";
#     for(my $i=0; $i < $ndat; $i++){
# 	$$tarr[$i]->Print_fmt1(OUT);
# 	printf OUT " %19.13f %+18.11e %13.7e %6d %8s %15.4f %10.4e %8.2e %6.2f %13.7e %8.2e\n",
# 	$$mjd[$i], $$dtau[$i], $$amb[$i], $$iamb[$i], $$src[$i], 
# 	$$frq[$i], $$amp[$i], $$err[$i], $$snr[$i], $$rat[$i], $$rerr[$i];

# 	if($i<10){
# 	    $$tarr[$i]->Print_fmt1();
# 	    printf STDOUT " %13f %+18.11e %13.7e %6d %8s %15.4f %10.4e %8.2e %6.2f %13.7e %8.2e\n",
# 	    $$mjd[$i], $$dtau[$i], $$amb[$i], $$iamb[$i], $$src[$i], 
# 	    $$frq[$i], $$amp[$i], $$err[$i], $$snr[$i], $$rat[$i], $$rerr[$i];
# 	}

#     }
#     close(OUT);
    
# }
