# @Version: $Id: Pdplt_dat.pm 118 2017-04-11 04:07:52Z vlbi $
#
## Expecting data format
## Xtr #########
# $antenna
# Station_name, Type, Type Number
#   marble2   azel         3                      
# $data 
# Flag, Az,       El,       dAz,    dEl,     Az_err, El_err, Source,    Initial El     
#   1  115.82560  37.61570 -0.05500 -0.01106 0.03235 0.07868 sun         37.3 
# *bad 231.47690  16.26910 -0.06157  0.00000 0.29807 0.07868 moon        16.6 
# $stats
##  drms = sqrt((dAz*cosEl^2+dEl^2)/N)
##      Avg dAz,  rms_dAz,Avg_dEl, rms_dEl,drms, Ngood, Ntotal    
#        0.0147   0.0516  0.0007  0.0310 0.0510 274 336 
#
#
## Err #########
#$antenna
# Station_name, Type, Type Number
#  marble2   azel         3                      
#$observed 
# Flag,  Az,      El,        dAz,      dEl,         sqrt(dAz*cosEl^2+dEl^2)     
# 1   115.82560   37.61570   -0.05500   -0.01106    0.04495  
# 1   118.68230   39.96650   -0.04116   -0.03634    0.04812  
# $observed_stats 
#  Sum(dAz*cosEl/eAz^2)/n, Sum(dEl/eEl^2)/n,  sqrt(Sum((dAz-<dAz>)^/eAz^2)/n), sqrt(Sum(dEl^/eEl^2)
# lonsum = Sum(dAz/eAz^2)/n;  lonrms = sqrt(Sum((dAz-<dAz>)^/eAz^2)/n)
# latsum = Sum(dEl/eEl^2)/n;  latrms = sqrt(Sum((dEl-<dEl>)^2/eEl^2)/n)
# dirms =  sqrt( Sum((dAz-<dAz>)^2/eAz^2 + (dEl-<dEl>)^2/eEl^2)/n )
# crssum = Sum(dAz*cosEl/eAz^2)/n;  crsrms = sqrt(Sum((dAz-<dAz>)^/eAz^2)/n)
#       lonsum,     lonrms,   latsum,    latrms,     dirms,    Ngood,  ntotal, crssum,   crsrmns  
#        0.02392    0.04509    0.00033    0.02823    0.04000    274    274    0.01670    0.03135
# $old_model
# * 
#   00021  2016  090  10  30  33 0
# $uncorrected
# Flag,  Az,       El,        dAz,        dEl,     sqrt(dAz*cosEl^2+dEl^2)     
#  1   115.82560   37.61570  -18.63201    1.21944   14.80912  
#  1   118.68230   39.96650  -18.61336    1.18537   14.31481  
# uncorrected_stats
#  Sum(dAz*cosEl/eAz^2)/n, Sum(dEl/eEl^2)/n,  sqrt(Sum((dAz-<dAz>)^/eAz^2)/n), sqrt(Sum(dEl^/eEl^2)
#       lonsum,     lonrms,   latsum,    latrms,     dirms,    Ngood,  ntotal, crssum,   crsrmns  
#      -18.71361    0.10960    1.14478    0.05146   13.47964    274    274  -12.72614    2.76746
# $fit_data 
# * 
#   00022  2016  095  02  52  49 1
# *
# $fit_stats
#   itry     RKai2_all, RKai2_Az RKai2_El   nfree
#      1        0.785   0.998   0.476        543       0.01276   -0.01330     3       3     
# $conditions 
# *  Condition Number
#    2.65E+02 
# * 
#     2.7    0.0    3.7    0.0    4.6    4.1    5.8 
# * 
# $correlation
# * 
#   1.000 
# * 
#   0.000  0.000
# $corrected
# Flag,  Az,       El,        dAz rsd,    dEl rsd,   distr,    Kai/eAz    Kai/eEl    Post eAz   Post eEl
#  distr = sqrt(dAz_rsd*cosEl^2+dEl_rsd^2)     
#  1   115.82560   37.61570   -0.07180   -0.00948    0.05766    0.02838    0.06089    0.02814    0.06054  
#  1   118.68230   39.96650   -0.05777   -0.03475    0.05628    0.02981    0.05702    0.02958    0.05665  
# $corrected_stats
#  Sum(dAz*cosEl/eAz^2)/n, Sum(dEl/eEl^2)/n,  sqrt(Sum((dAz-<dAz>)^/eAz^2)/n), sqrt(Sum(dEl^/eEl^2)
#       lonsum,     lonrms,   latsum,    latrms,     dirms,    Ngood,  ntotal, crssum,   crsrmns  
#        0.00000    0.04165    0.00000    0.00632    0.03981    274    274    0.00017    0.02931
# $new_model
# * 
#   00022  2016  095  02  52  49 0

package Pdplt_dat;
use Exporter;
use Carp;

@ISA = qw(Exporter);

#@EXPORT = qw(Mjd Doy Soy Sod Print_fmt1 Print_fmt2 Print_fmt3 
#	     Print_fmt4 Print_fmt10 Str_fmt3 Set_mjd2Time 
#	     Set_time_strydhms Set_time_strymdhms Set_time_ydhms, 
#            Set_time_Max);
#  Max time = 3000/1/1 

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    return $this;
}

sub mode_check( $$ ){
#    my $pkg=shift;
    my $line=shift;
    my $mode=shift;
    
    if( $line=~/\$antenna/ ){   $mode =1; 
    }elsif($line=~/\$observed_stats/){ $mode =3;
    }elsif($line=~/\$observed/){    $mode =2;
    }elsif($line=~/\$old_model/){ $mode =4;
    }elsif($line=~/\$uncorrected_stats/){  $mode =6;
    }elsif($line=~/\$uncorrected$/){  $mode =5;
    }elsif($line=~/\$fit_data/){  $mode =7;
    }elsif($line=~/\$fit_stats/){  $mode =8;
    }elsif($line=~/\$conditions/){  $mode =9;
    }elsif($line=~/\$correlation/){  $mode =10;
    }elsif($line=~/\$corrected_stats/){  $mode =12;
    }elsif($line=~/\$corrected$/){  $mode =11;
    }elsif($line=~/\$new_model/){  $mode =13;}
    return $mode;
}

sub Read_err( $$ ){
    my $pkg = shift;
    my $infile = shift;
    unless(open(IN,$infile)){
	print "Err: Pdplt_dat::Read_err(): Failed to open infile($infile) \n";
	return -1;
    }
    
    my $mode =0;
    my (@azarr,@elarr, );
    my (@obs_arr, @old_model, @new_model, @uncrrected, @fit_data, @conditions, @correlation, @corrected, $ndat);
    $ndat=0;
    my $line = <IN>;
    while(! eof(IN) ){
	next if($line =~/^\*/);
	chomp($line);
	my $nmode=&mode_check($line, $mode) ;
	if($nmode != $mode){ $mode=$nmode; next;}
	
	if($mode == 1){ # antenna 
	    $pkg->{antenna} = $line;
	    $pkg->{antenna_cmnt} = "# Station_name, Type, Type Number";
	    next;
	}elsif($mode == 2){ # obseved
	    push(@observed,($line));
	    $pkg->{observed} = \@observed;
	    $pkg->{observed_cmnt} = "# Flag,  Az,      El,        dAz,      dEl,         sqrt(dAz*cosEl^2+dEl^2)";
	    next;
	}elsif($mode == 3){ # $observed_stats
	    $pkg->{observed_stat} = $line;
	    $pkg->{observed_stat_cmnt} = " lonsum,     lonrms,   latsum,    latrms,     dirms,    Ngood,  ntotal, crssum,   crsrmns";
	    next;
	}elsif($mode == 4){ # $old_model
	    push(@old_model,($line));
	    $pkg->{old_model} = \@old_model;
	    next;	    
	}elsif($mode == 5){ # $uncorrected
	    push(@uncorrected,($line));
	    $pkg->{uncorrected} = \@uncorrected;
	    $pkg->{uncorrected_cmnt}= "Flag,  Az,       El,        dAz,        dEl,     sqrt(dAz*cosEl^2+dEl^2)";     
	    next;	    
	}elsif($mode == 6){ # $uncorrected_stat
	    $pkg->{uncorrected_stat} = $line;
	    $pkg->{uncorrected_stat_cmnt} = " lonsum,     lonrms,   latsum,    latrms,     dirms,    Ngood,  ntotal, crssum,   crsrmns";
	    next;
	}elsif($mode == 7){ # $fit_data
	    $pkg->{fit_data} = $line;
	    next;
	}elsif($mode == 8){ # $fit_stat
	    $pkg->{fit_stat} = $line;
	    $pkg->{fit_stat_cmnt} = " itry     RKai2_all, RKai2_Az RKai2_El   nfree";
	    next;
	}elsif($mode == 9){ # $conditions
	    push(@conditions,($line));
	    $pkg->{conditions} = \@conditions;
	    next;
	}elsif($mode == 10){ # $correlation
	    push(@correlation,($line));
	    $pkg->{correlation} = \@correlation;
	    next;
	}elsif($mode == 11){ # $corrected
	    push(@corrected,($line));
	    $pkg->{corrected} = \@corrected;
	    $pkg->{corrected_cmnt} = " # Flag,  Az,       El,        dAz rsd,    dEl rsd,   distr,    Kai/eAz    Kai/eEl    Post eAz   Post eEl";
	    $ndat++;
	    next;
	}elsif($mode == 12){ # $corrected_stat
	    $pkg->{corrected_stat} = $line;
	    $pkg->{corrected_stat_cmnt} = " lonsum,     lonrms,   latsum,    latrms,     dirms,    Ngood,  ntotal, crssum,   crsrmns";
	    next;
	}elsif($mode == 13){ # $new_model
	    push(@new_model,($line));
	    $pkg->{new_model} = \@new_model;
	    next;
	}	
    }continue{
	$line=<IN>;
    }	
    
    close(IN);

    $pkg->{ndat} = $ndat;
}


sub Observed_lines($ ) {
    my $pkg = shift;
    my $obsline = $pkg->{observed};
    my $obs_cmnt = $pkg->{observed_cmnt};
    return ($obsline, $obs_cmnt);
}
sub Observed_fout( $$$ ) {
    my $pkg = shift;
    my $outfile = shift;
    my $gpflag = shift;
    my $obdline = $pkg->{observed};
    my $obd_cmnt = $pkg->{observed_cmnt};

    unless(open(OUT,">$outfile")){
	print STDERR "E Failed to open outfile ($outfile) \n";
	return -1;
    }
    my $ndat = @$obdline;
   my ($az_avg, $az_rms, $el_avg, $el_rms, $dirms, $Ngd, $Ntot, $azcos_avg, $azcos_rms)
       =$pkg->Obs_stat();

   my ($caz_avg, $caz_rms, $cel_avg, $cel_rms, $cdirms, $Ngdc, $Ntotc, $cazcos_avg, $cazcos_rms)
       =$pkg->Crctd_stat();

    printf OUT "Ndata = %d/%d used.  Unit= deg. \n", $Ngd, $Ntot;
    printf OUT "#Obs <dAz>=%+8.5f RMS= %7.5f <dAz*Cos>=%+8.5f RMS= %7.5f <dEl>=%+8.5f RMS= %7.5f\n",
    $az_avg,$az_rms, $azcos_avg, $azcos_rms, $el_avg, $el_rms;
    printf OUT "#     After Fit dAz_RMS= %7.5f            dAz*Cos RMS= %7.5f            dEl RMS= %7.5f\n",
    $caz_rms,  $cazcos_rms, $cel_rms;

    print OUT "# $obd_cmnt \n";
    my $cnt=0;
    for(my $i=0; $i<$ndat; $i++){
	$$obdline[$i] =~/\s*/;
	my @terms = split(/\s+/,$'); # ');
	next if( $gpflag > 0 && ( $terms[0] == 0) );
	printf OUT "%s \n", $$obdline[$i];
	$cnt++;
    }
    
    close(OUT);
    return $cnt;
}

sub Corrected_lines( $ ){
    my $pkg = shift;
    my $crdline = $pkg->{corrected};
    my $crd_cmnt = $pkg->{corrected_cmnt};
    return ($crdline, $crd_cmnt);
}


sub Corrected_fout( $$$ ) {
    my $pkg = shift;
    my $outfile = shift;
    my $gpflag = shift;
    my $crdline = $pkg->{corrected};
    my $crd_cmnt = $pkg->{corrected_cmnt};

    unless(open(OUT,">$outfile")){
	print STDERR "E Failed to open outfile ($outfile) \n";
	return -1;
    }
    my $ndat = @$crdline;
   my ($az_avg, $az_rms, $el_avg, $el_rms, $dirms, $Ngd, $Ntot, $azcos_avg, $azcos_rms)
       =$pkg->Obs_stat();

   my ($caz_avg, $caz_rms, $cel_avg, $cel_rms, $cdirms, $Ngdc, $Ntotc, $cazcos_avg, $cazcos_rms)
       =$pkg->Crctd_stat();

    printf OUT "Ndata = %d/%d used.  Unit= deg. \n", $Ngd, $Ntot;
    printf OUT "#Obs <dAz>=%+8.5f RMS= %7.5f <dAz*Cos>=%+8.5f RMS= %7.5f <dEl>=%+8.5f RMS= %7.5f\n",
    $az_avg,$az_rms, $azcos_avg, $azcos_rms, $el_avg, $el_rms;
    printf OUT "#     After Fit dAz_RMS= %7.5f            dAz*Cos RMS= %7.5f            dEl RMS= %7.5f\n",
    $caz_rms,  $cazcos_rms, $cel_rms;

    print OUT "# $crd_cmnt \n";
    my $cnt=0;
    for(my $i=0; $i<$ndat; $i++){
	$$crdline[$i] =~/\s*/;
	my @terms = split(/\s+/,$'); # ');
	next if( $gpflag > 0 && ( $terms[0] == 0) );
	printf OUT "%s \n", $$crdline[$i];
	$cnt++;
    }
    
    close(OUT);
    return $cnt;
}

sub Obs_stat( $ ){
    $pkg=shift;
    my $line = $pkg->{observed_stat};
    $line =~/\s*/;
    my @terms = split(/\s+/,$'); #');
#    my ($az_avg, $az_rms, $el_avg, $el_rms, $dirms, $Ngd, $Ntot, $azcos_avg, $azcos_rms)
#	= @terms;
    return @terms;
}

# Corrected (after Fit) RMS
sub Crctd_stat( $ ){
    $pkg=shift;
    my $line = $pkg->{corrected_stat};
    $line =~/\s*/;
    my @terms = split(/\s+/,$'); #');
#    my ($az_avg, $az_rms, $el_avg, $el_rms, $dirms, $Ngd, $Ntot, $azcos_avg, $azcos_rms)
#	= @terms;
    return @terms;
}


1;
