# @Ver: $Id: Time_lib.pm 48 2014-11-30 03:51:32Z sekido $
# Expectind data format is Soruce name and coordiantes.
# $source Venus
# 2014-Dec-05 23:00 *   17 33 06.44 -23 49 51.9 124.9013   5.5539  -3.88   0.83 1.67495064925121  -3.4757899  10.3393 /T  14.0701
# 2014-Dec-05 23:05 *   17 33 07.58 -23 49 53.1 125.6958   6.3786  -3.88   0.83 1.67494368200662  -3.4725589  10.3402 /T  14.0712
#
package Planets;
#use Exporter;
#use Carp;
#@ISA = qw(Exporter);

BEGIN{
    $AU = 149597870.691; # (km)
    %Month = ('Jan' =>1, 'Feb' =>2, 'Mar' =>3, 'Apr' =>4,
	      'May' =>5, 'Jun' =>6, 'Jul' =>7, 'Aug' =>8,
	      'Sep' =>9, 'Oct' => 10, 'Nov' =>11, 'Dec' =>12);
    $PI = atan2(1.,1.)*4.;
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Source($){
    my $pkg = shift;
    return $pkg->{source};
}


sub SetFile($$){
    ($pkg, $infile)  = @_;
    $pkg->{file} = $infile;
    
    unless(open(IN,$infile)){
	print "Err Planet::SetFile() failed to opne file($infile)\n";
	return -1;
    }
    my (@tarr, @ra, @dec);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	if(/\$source\s+(\S+)/){
	    $pkg->{source} = $1;
	}elsif(/\s*(\d{4}-\w+-\d\d)\s+/){
	    my @ymd = split(/-/,$1);
	    my @terms = split(/\s+/, $' ) ;   #');
	    my @hm = split(/:/,$terms[0]);
	    my $t1 = new Time_lib;
	    $t1->Set_time_ymd($ymd[0], $Month{$ymd[1]}, $ymd[2], $hm[0], $hm[1], 0);
	    $tarr[$cnt] = $t1;
	    $ra[$cnt] = sprintf("%02d%02d%06.3f",$terms[2],$terms[3],$terms[4]);
	    $dec[$cnt] = sprintf("%+03d%02d%06.3f",$terms[5],$terms[6],$terms[7]);
	    $cnt++;
	}elsif(/\$EOE/){
	    last;
	}
    }
    $pkg->{Tarr} = \@tarr;
    $pkg->{Ra} = \@ra;
    $pkg->{Dec} = \@dec; 
    $pkg->{ndat} = $cnt;

    close(IN);
}

# return format ex.) jupiter,094001.88,+144520.5,2000
# return format ex.) 094001.88,+144520.5,2000
sub Radec($$){
    my $pkg = shift;
    my $t1 = shift;
    my $tarr = $pkg->{Tarr};
    my $ndat = $pkg->{ndat};
    my $ra = $pkg->{Ra};
    my $dec = $pkg->{Dec};
    if($t1->Mjd() > $$tarr[$ndat-1]->Mjd() ||
       $t1->Mjd() < $$tarr[0]->Mjd() ){
	print "Err Requested time(%s) is out of data range(%s - %s)\n",
	$t1->Str_fmt1(1), $tarr[0]->Str_fmt1(1), $tarr[$ndat-1]->Str_fmt1(1);
	return (0,0);
    }
    for($i=0; $i<$ndat; $i++){
	last if ($t1 < $$tarr[$i]);
    }
    return ($$ra[$i-1], $$dec[$i-1]);
}

1;
