#  calc_skd  apr.prtl format Object 
# @Version: $Id: Prtl_fmt.pm 48 2014-11-30 03:51:32Z sekido $
#
package Prtl_fmt;
use Exporter;
use Time_lib;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
 
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Ndat($){
    my $this = shift;
    $this->{ndat};
}

sub Tarr($){
    my $this = shift;
    return $this->{tarr};
}

sub Print_Orgatmfm($;$){
    my ($this, $out) = @_;
    my $p = caller;
    my $H;
    my $ndat = $this->{ndat};
    my $tarr = $this->{tarr};
    if(defined($out)){
	if($out !~/^main/){ $H = $p . "::" . $out;}
	else{ $H =  $out;}
    }else{
	$H = STDOUT;
    }
    
    my $dry_datmx = $this->{dry_datmx};
    my $dry_datmy = $this->{dry_datmy};
    my $wet_datmx = $this->{wet_datmx};
    my $wet_datmy = $this->{wet_datmy};
    printf $H "## UTC  fm_dry_x, fm_dry_y, fn_wet_x, fm_wet_y.\n";
    for(my $i=0; $i<$ndat; $i++){
	$$tarr[$i]->Print_fmt1($H);
	printf $H " %+8.4f %+8.4f %+8.4f %+8.4f\n",
	$$dry_datmx[$i], $$dry_datmy[$i], $$wet_datmx[$i], $$wet_datmy[$i];  
    }
        
}
 # Xstn Dry mapping function by time 
sub Dryx_t($$){
    my ($this, $t) = @_;
    my $i =0;
    my $ndat = $this->{ndat};
    my $tarr = $this->{tarr};
    my $dry_datmx = $this->{dry_datmx};
    my $dry_datmy = $this->{dry_datmy};

    $i++ while($i<$ndat && $t > $$tarr[$i]);
    if( $i == $ndat){
	printf STDERR "Error: t=(%s) is out of tarr range\n", $t->Str_fmt1();
	exit(1);
    }
    return $$dry_datmx[$i]  if( $t == $$tarr[$i]);
    printf STDERR "Error: t(%s) != $tarr[$i]=(%s)\n", 
    $t->Str_fmt1(),$$tarr[$i]->Str_fmt1();
    exit(1);
}

 # Ystn Dry mapping function by time 
sub Dryy_t($$){
    my ($this, $t) = @_;
    my $i =0;
    my $ndat = $this->{ndat};
    my $tarr = $this->{tarr};
    my $dry_datmy = $this->{dry_datmy};
    
    $i++ while($i<$ndat && $t > $$tarr[$i]);
    if( $i == $ndat){
	printf STDERR "Error: t=(%s) is out of tarr range\n", $t->Str_fmt1();
	exit(1);
    }
    return $$dry_datmy[$i]  if( $t == $$tarr[$i]);
    printf STDERR "Error: t(%s) != $$tarr[$i]=(%s)\n", 
    $t->Str_fmt1(),$$tarr[$i]->Str_fmt1();
    exit(1);
}

 # Xstn Wet mapping function by time 
sub Wetx_t($$){
    my ($this, $t) = @_;
    my $i =0;
    my $ndat = $this->{ndat};
    my $tarr = $this->{tarr};
    my $wet_datmx = $this->{wet_datmx};

    $i++ while($i<$ndat && $t > $$tarr[$i]);
    if( $i == $ndat){
	printf STDERR "Error: t=(%s) is out of tarr range\n", $t->Str_fmt1();
	exit(1);
    }
    return $$wet_datmx[$i]  if( $t == $$tarr[$i]);
    printf STDERR "Error: t(%s) != $$tarr[$i]=(%s)\n", 
    $t->Str_fmt1(),$$tarr[$i]->Str_fmt1();
    exit(1);
}

 # Ystn Wet mapping function by time 
sub Wety_t($$){
    my ($this, $t) = @_;
    my $i =0;
    my $ndat = $this->{ndat};
    my $tarr = $this->{tarr};
    my $wet_datmy = $this->{wet_datmy};
    $i++ while($i<$ndat && $t > $$tarr[$i]);
    if( $i == $ndat){
	printf STDERR "Error: t=(%s) is out of tarr range\n", $t->Str_fmt1();
	exit(1);
    }
    return $$wet_datmy[$i]  if( $t == $$tarr[$i]);
    printf STDERR "Error: t(%s) != $tarr[$i]=(%s)\n", 
    $t->Str_fmt1(),$$tarr[$i]->Str_fmt1();
    exit(1);
}

 # Xstn Dry mapping function by index  
sub Dryx_i($$){
    my ($this, $ix) = @_;
    my $ndat = $this->{ndat};
    my $dry_datmx = $this->{dry_datmx};
    if ($ix < 0 || $ix >= $ndat){
	print STDERR "Error: index $ix is out of range [0,$ndat-1]\n";
	exit(1);
    }
    return $$dry_datmx[$ix];
}

 # Ystn Dry mapping function by index  
sub Dryy_i($$){
    my ($this, $ix) = @_;
    my $ndat = $this->{ndat};
    my $dry_datmy = $this->{dry_datmy};
    if ($ix < 0 || $ix >= $ndat){
	print STDERR "Error: index $ix is out of range [0,$ndat-1]\n";
	exit(1);
    }
    return $$dry_datmy[$ix];
}

 # Xstn Wet mapping function by index  
sub Wetx_i($$){
    my ($this, $ix) = @_;
    my $ndat = $this->{ndat};
    my $wet_datmx = $this->{wet_datmx};
   if ($ix < 0 || $ix >= $ndat){
	print STDERR "Error: index $ix is out of range [0,$ndat-1]\n";
	exit(1);
    }
    return $$wet_datmx[$ix];
}

 # Ystn Wet mapping function by index  
sub Wety_i($$){
    my ($this, $ix) = @_;
    my $ndat = $this->{ndat};
    my $wet_datmy = $this->{wet_datmy};

    if ($ix < 0 || $ix >= $ndat){
	print STDERR "Error: index $ix is out of range [0,$ndat-1]\n";
	exit(1);
    }
    return $$wet_datmy[$ix];
}


sub Read($$){
    my ($this, $fname) = @_;
    open(IN,$fname) || die "Cannot open file $fname\n";

    my (@tarr, @elx, @ely, $xname, $yname, @dt_da, @dt_dd, @dt_dr);
    my (@dr_da, @dr_dd, @dr_dr, @dry_datmx, @dry_datmy, @wet_datmx, @wet_datmy );
    my (@ddry_datmx,@ddry_datmy,@dwet_datmx,@dwet_datmy );
    my (@xdry_ge, @xdry_gn, @ydry_ge, @ydry_gn);
    my (@xdryr_ge, @xdryr_gn, @ydryr_ge, @ydryr_gn);
    my (@dt_xion, @dt_yion, @dr_xion, @dr_yion);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	/^\s*/;
	my @terms = split(/\s+/,$'); # ')
	if( @terms < 10){
	    print STDERR "Error:Format is wrong\n";
	    print STDERR " i=$cnt, line= $_\n";
	    exit(1);
	}
	my $t1 = new Time_lib;
	$t1->Set_time_strydhms($terms[0],$terms[1]);
	push(@tarr,$t1);
	push(@elx,$terms[8]);
	push(@ely,$terms[9]);
	$xname = $terms[3] unless(defined($xname));
	$yname = $terms[5] unless(defined($yname));
	my $line = <IN>;
	unless($line  =~/SRC:\s+(\S.*)/){
	    print STDERR "Error: Format is wrong. SRC: was expected\n";
	    print STDERR "line= $line\n";
	    exit(1);
	}
	my $tmp1 = $1;
	@terms = split(/\s+/,$tmp1);
	if(@terms < 6){
	    print STDERR "Format is wrong, line=$tmp1 \n";
	    exit(1);
	}
	push(@dt_da,$terms[0]);
	push(@dt_dd,$terms[1]);
	push(@dt_dr,$terms[2]);
	push(@dr_da,$terms[3]);
	push(@dr_dd,$terms[4]);
	push(@dr_dr,$terms[5]);
	$line = <IN>;
	unless($line =~/ATM:\s+(\S.*)/){
	    print STDERR "Error: Format is wrong. ATM: was expected\n";
	    print STDERR "line= $line\n";
	    exit(1);
	}
	$tmp1 = $1;
	@terms = split(/\s+/,$tmp1);
	if(@terms < 8){
	    print STDERR "Format is wrong, line=$tmp1 \n";
	    exit(1);
	}
	push(@dry_datmx,$terms[0]);
	push(@dry_datmy,$terms[1]);
	push(@wet_datmx,$terms[2]);
	push(@wet_datmy,$terms[3]);
	push(@ddry_datmx,$terms[4]);
	push(@ddry_datmy,$terms[5]);
	push(@dwet_datmx,$terms[6]);
	push(@dwet_datmy,$terms[7]);
	$line = <IN>;
	unless($line =~/ATMG:\s+(\S.*)/){
	    print STDERR "Error: Format is wrong. ATMG: was expected\n";
	    print STDERR "line= $line\n";
	    exit(1);
	}
	$tmp1 = $1;
	@terms = split(/\s+/,$tmp1);
	if(@terms < 8){
	    print STDERR "Format is wrong, line=$tmp1 \n";
	    exit(1);
	}
	push(@xdry_ge,$terms[0]);
	push(@xdry_gn,$terms[1]);
	push(@ydry_ge,$terms[2]);
	push(@ydry_gn,$terms[3]);
	push(@xdryr_ge,$terms[4]);
	push(@xdryr_gn,$terms[5]);
	push(@ydryr_ge,$terms[6]);
	push(@ydryr_gn,$terms[7]);
	$line = <IN>;
	unless($line =~/IONP:\s+(\S.*)/){
	    print STDERR "Error: Format is wrong. IONP: was expected\n";
	    print STDERR "line= $line\n";
	    exit(1);
	}
	$tmp1 = $1;
	@terms = split(/\s+/,$tmp1);
	if(@terms < 4){
	    print STDERR "Format is wrong, line=$tmp1 \n";
	    exit(1);
	}
	push(@dt_xion,$terms[0]);
	push(@dt_yion,$terms[1]);
	push(@dr_xion,$terms[2]);
	push(@dr_yion,$terms[3]);
	$cnt++;
    }
    close(IN);

    $this->{ndat} = $cnt;
    $this->{tarr} = \@tarr;
    $this->{elx} = \@elx;
    $this->{ely} = \@ely;
    $this->{xname} = $xname;
    $this->{yname} = $yname;

    $this->{dt_da} = \@dt_da;
    $this->{dt_dd} = \@dt_dd;
    $this->{dt_dr} = \@dt_dr;
    $this->{dr_da} = \@dr_da;
    $this->{dr_dd} = \@dr_dd;
    $this->{dr_dr} = \@dr_dr;

    $this->{dry_datmx} = \@dry_datmx;
    $this->{dry_datmy} = \@dry_datmy;
    $this->{wet_datmx} = \@wet_datmx;
    $this->{wet_datmy} = \@wet_datmy;
    $this->{ddry_datmx} = \@ddry_datmx;
    $this->{ddry_datmy} = \@ddry_datmy;
    $this->{dwet_datmx} = \@dwet_datmx;
    $this->{dwet_datmy} = \@dwet_datmy;

    $this->{xdry_ge} = \@xdry_ge;
    $this->{xdry_gn} = \@xdry_gn;
    $this->{ydry_ge} = \@ydry_ge;
    $this->{ydry_gn} = \@ydry_gn;
    $this->{xdryr_ge} = \@xdryr_ge;
    $this->{xdryr_gn} = \@xdryr_gn;
    $this->{ydryr_ge} = \@ydryr_ge;
    $this->{ydryr_gn} = \@ydryr_gn;

    $this->{dt_xion} = \@dt_xion;
    $this->{dt_yion} = \@dt_yion;
    $this->{dr_xion} = \@dr_xion;
    $this->{dr_yion} = \@dr_yion;

}

1;
