# @Version: $Id: SB_kombfmt.pm 48 2014-11-30 03:51:32Z sekido $
#
package SB_kombfmt;

#use Exporter;
#@ISA = qw(Exporter);

# @EXPORT = qw();

BEGIN{
    
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

# use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;

sub Expcode($){
    my $pkg = shift;
    $pkg->{exp_code};
}

sub Baseid($){
    my $pkg = shift;
    $pkg->{baseid};
}

sub Start_tm($){
  my $pkg = shift;
  $pkg->{start_time};
}


sub Src_name($){
    my $pkg = shift;
    $pkg->{src_name};
}

sub Xst_name($){
    my $pkg = shift;
    $pkg->{Xstname};
}
sub Yst_name($){
    my $pkg = shift;
    $pkg->{Ystname};
}

sub Coars_del($){
    my $pkg = shift;
    $pkg->{sngl_delay};
}
sub Fine_del($){
    my $pkg = shift;
    ${$pkg->{grp_delay}}[0];
}
sub Fine_rat($){
    my $pkg = shift;
    ${$pkg->{grp_delay}}[1];
}
sub SNR($){
    my $pkg = shift;
    $pkg->{fine_snr};
}

sub Fine_amp($){
    my $pkg = shift;
    $pkg->{fine_amp};
}

sub Coarse_amp($){
    my $pkg = shift;
    $pkg->{fine_amp};
}

sub PRT_tm($){
    my $pkg = shift;
    unless(defined($pkg->{prt_time})){
	print STDERR "{prt_time} is undefined\n";
    }else{
	$pkg->{prt_time};
    };
}

sub Cout_files($){
    my $pkg = shift;
    @{$pkg->{cout_file}};
}

sub Fmean($){
    my $pkg = shift;
    $pkg->{f_mean};
}

sub Read($$){
    my ($pkg,$fname) = @_;
    $pkg->{fname} = $fname;
    my $in;
    unless(open($in,$fname)){
	print STDERR "Error in SB_kombfmt: Open faild to read $fname \n";
	return -1;
    }
    my $rmode =0;
    my $tmfmt = "(\\d{4}/\\d{3})\\s+(\\d\\d:\\d\\d:[\\d,.]+)";
    my $nch=0;
    while(<$in>){
	chomp;
	next if(/^\#/);
	if(/PRT_TIME/){
	    unless(m!:${tmfmt}!){
		print STDERR "Error in SB_kombfmt::Read(): PRT TIME unmached\n";
		print STDERR "line = $_ \n";
		exit(1);
	    }
	    my @tmstr = ($1,$2);
	    my $tm = new Time_lib;
	    $tm->Set_time_strydhms(@tmstr);
	    $pkg->{prt_time} = $tm;
	}elsif(/NCH\s+:(\d+)/){
	    $nch = $pkg->{nch} = $1;
	}elsif(/EXP_CODE:[\s\t]*(\w+)/){
	    $pkg->{exp_code} = $1;
	}elsif(/BASEID:\s*(\w+)/){
	    $pkg->{baseid} = $1;
	}elsif(m!OBS_TIME:\s*${tmfmt}\s+${tmfmt}!){
	    my $tm_st = new Time_lib;
	    my $tm_et = new Time_lib;
	    $tm_st->Set_time_strydhms($1,$2);
	    $tm_et->Set_time_strydhms($3,$4);
	    $pkg->{start_time} = $tm_st;
	    $pkg->{stop_time} = $tm_st;
	}elsif(/SRC_NAME:\s*(\S+)/){
	    $pkg->{src_name} = $1;
	}elsif(/RADEC RA\s*:\s+(\d+\s+\d+\s+[\d,.]+)\s*DEC:\s*([-,\d]+\s+\d+[\d,.]+)/){
	    $pkg->{src_ra} = $1;	    
	    $pkg->{src_dec}= $2;
	}elsif(/STATIONS:\s*(\S+)\s+(\S+)/){
	    $pkg->{Xstname} = $1;
	    $pkg->{Ystname} = $2;
	}elsif(/Stn1_XYZ:\s*(\S+\s+\S+\s+\S+)/){
	    my @xyz = split(/\s+/,$1);
	    $pkg->{Xst_xyz} = \@xyz;
	}elsif(/Stn2_XYZ:\s*(\S+\s+\S+\s+\S+)/){
	    my @xyz = split(/\s+/,$1);
	    $pkg->{Yst_xyz} = \@xyz;
	}elsif(/APRI_DEL:\s*(\S+\s+\S+)/){
	    my @apr = split(/s+/,$1);
	    my $line =<$in>; 
	    $line =~/:\s+(\S+\s+\S+)/;
	    push(@apr,split(/\s+/,$1));
	    $pkg->{apri} = \@apr;
	}elsif(/CLCK_PRM:\s*(\S+\s+\S+)/){
	    my @clk = split(/\s+/,$1);
	    $pkg->{clock} = \@clk;
	}elsif(/ERP_DATA:\s*(\S+\s+\S+\s+\S+)/){
	    my @eop = split(/\s+/,$1);
	    $pkg->{eop} = $1;
	}elsif(/SMPLRATE:\s*(\S+)/){
	    $pkg->{fsample} = $1;
	}elsif(/PP:\s*(\S+)\s+\(sec\)/){
	    $pkg->{pp_sec} = $1;
	}elsif(/INTG_SEC:\s*(\S+)\s+\(sec\)/){
	    $pkg->{integ_sec} = $1;
	}elsif(/NPP:\s*(\S+)/){
	    $pkg->{npp} = $1;
	}elsif(/PRC_HOST\s*:/){
	    unless(m!PRC_HOST\s*:\s*(\S+)\s+PRC_DATE\s*:(\d{4}/\d{3})\s+([\d:,.]+)\s+COUT_FILE\s*:\s*(\S+)!){
		print STDERR "Error in SB_kombfmt::Read(): PRC_HOST format is unexpected\n";
		print STDERR "line = $_\n";
		exit(1);
	    };
	    my $host1 = $1;
	    my @tmdat1 = ($2, $3);
	    my $cfname =$4;
	    if(defined($pkg->{prc_host})){
		push(@{$pkg->{prc_host}}, ($host1));
	    }else{
		my @lst = ($host1);
		$pkg->{prc_host} = \@lst;
	    }
	    my $tm1 = new Time_lib;
	    $tm1->Set_time_strydhms(@tmdat1);
	    if(defined($pkg->{prc_time})){
		push(@{$pkg->{prc_time}}, ($tm1));
	    }else{
		my @lst = ($tm1);
		$pkg->{prc_time} = \@lst;
	    }

	    if(defined($pkg->{cout_file})){
		push(@{$pkg->{cout_file}}, ($cfname));
	    }else{
		my @lst = ($cfname);
		$pkg->{cout_file} = \@lst;
	    }
	}elsif(/NCH\s*:\s*(\S+)/){
	    $pkg->{nch} = $1;
	}elsif(/FRING_AMP\s*:\s*(\S+.+)$/){
	    my @arr = split(/\s+/,$1);
	    $pkg->{fring_amp} = \@arr;
	}elsif(/FRING_PHS\s*:\s*(\S+.+)$/){
	    my @arr = split(/\s+/,$1);
	    $pkg->{fring_phs} = \@arr;
	}elsif(/FREQ_TABL\s*:/){
	    my (@frq, @pcalf, @ulsb);
	    for(my $i=0; $i < $nch; $i++){
		my $line = <$in>;
		$line =~/\d+:\s*(\S+)\s+(\S+)\s+(\S+)/;
		push(@frq,($1));
		push(@pcalf,($2));
		push(@ulsb,($3));
	    }
	    $pkg->{rfrq} = \@frq;
	    $pkg->{pcalf} = \@pcalf;
	    $pkg->{ulsb} = \@ulsb;
	}elsif(/Freq_GCM\s*:\s*(\S+)\s*AMBG:\s*(\S+)/){
	    $pkg->{gcmfrq} = $1;
	    $pkg->{ambg} = $1;
	}elsif(/F_mean\s*:\s*(\S+)\s*BW_effectv:\s+(\S+)/){
	    $pkg->{f_mean} = $1;
	    $pkg->{bw_effect} = $2;
	}elsif(/FINE_AMPLITUDE\s*:\s*(\S+)\s+PHASE:\s*(\S+)\s*SNR\s*:\s*(\S+)/){
	    $pkg->{fine_amp} = $1;
	    $pkg->{fine_phs} = $2;
	    $pkg->{fine_snr} = $3;
	}elsif(/FINE_RESD\S+:\s*(\S+\s+\S+)/){
	    my @fine_rsd = split(/\s+/,$1);
	    $pkg->{fine_rsd} = \@fine_rsd;
	}elsif(/CORAS_RESD\s*:\s*(\S+\s+\S+)/){
	    my @cors_rsd = split(/\s+/,$1);
	    $pkg->{corase_rsd} = \@cors_rsd;;
	}elsif(/APRIORI_DELAY\S+:\s*(\S+)\s+RATE.+:(\S+)/){
	    $pkg->{apri_del} = $1;
	    $pkg->{apri_rat} = $2;
	}elsif(/DELAY_RESID.+:(\S+)\s+RATE.+:(\S+)/){
	    my @rsd = ($1, $2);
	    $pkg->{del_rsd} = \@rsd;
	}elsif(/SNGL_BND_DEL_.+:(\S+)\s+RATE.+:(\S+)/){
	    my @sngl = ($1,$2);
	    $pkg->{sngl_delay} = \@sngl;
	}elsif(/GROUP_DELAY_.+:(\S+)\s+RATE.+:(\S+)/){
	    my @grp_del = ($1,$2);
	    $pkg->{grp_delay} = \@grp_del;
	}
    }


}

## Reading data starting with '#'
sub Read2($$){
    my ($pkg,$fname) = @_;
    $pkg->{fname} = $fname;
    my $in;
    unless(open($in,$fname)){
	print STDERR "Error in SB_kombfmt: Open faild to read $fname \n";
	return -1;
    }
    my $rmode =0;
    my $tmfmt = "(\\d{4}/\\d{3})\\s+(\\d\\d:\\d\\d:[\\d,.]+)";
    my $nch=0;
    while(<$in>){
	chomp;
#	next if(/^\#/);
	if(/PRT_TIME/){
	    unless(m!:${tmfmt}!){
		print STDERR "Error in SB_kombfmt::Read(): PRT TIME unmached\n";
		print STDERR "line = $_ \n";
		exit(1);
	    }
	    my @tmstr = ($1,$2);
	    my $tm = new Time_lib;
	    $tm->Set_time_strydhms(@tmstr);
	    $pkg->{prt_time} = $tm;
	}elsif(/NCH\s+:(\d+)/){
	    $nch = $pkg->{nch} = $1;
	}elsif(/EXP_CODE:[\s\t]*(\w+)/){
	    $pkg->{exp_code} = $1;
	}elsif(/BASEID:\s*(\w+)/){
	    $pkg->{baseid} = $1;
	}elsif(m!OBS_TIME:\s*${tmfmt}\s+${tmfmt}!){
	    my $tm_st = new Time_lib;
	    my $tm_et = new Time_lib;
	    $tm_st->Set_time_strydhms($1,$2);
	    $tm_et->Set_time_strydhms($3,$4);
	    $pkg->{start_time} = $tm_st;
	    $pkg->{stop_time} = $tm_st;
	}elsif(/SRC_NAME:\s*(\S+)/){
	    $pkg->{src_name} = $1;
	}elsif(/RADEC RA\s*:\s+(\d+\s+\d+\s+[\d,.]+)\s*DEC:\s*([-,\d]+\s+\d+[\d,.]+)/){
	    $pkg->{src_ra} = $1;	    
	    $pkg->{src_dec}= $2;
	}elsif(/STATIONS:\s*(\S+)\s+(\S+)/){
	    $pkg->{Xstname} = $1;
	    $pkg->{Ystname} = $2;
	}elsif(/Stn1_XYZ:\s*(\S+\s+\S+\s+\S+)/){
	    my @xyz = split(/\s+/,$1);
	    $pkg->{Xst_xyz} = \@xyz;
	}elsif(/Stn2_XYZ:\s*(\S+\s+\S+\s+\S+)/){
	    my @xyz = split(/\s+/,$1);
	    $pkg->{Yst_xyz} = \@xyz;
	}elsif(/APRI_DEL:\s*(\S+\s+\S+)/){
	    my @apr = split(/s+/,$1);
	    my $line =<$in>; 
	    $line =~/:\s+(\S+\s+\S+)/;
	    push(@apr,split(/\s+/,$1));
	    $pkg->{apri} = \@apr;
	}elsif(/CLCK_PRM:\s*(\S+\s+\S+)/){
	    my @clk = split(/\s+/,$1);
	    $pkg->{clock} = \@clk;
	}elsif(/ERP_DATA:\s*(\S+\s+\S+\s+\S+)/){
	    my @eop = split(/\s+/,$1);
	    $pkg->{eop} = $1;
	}elsif(/SMPLRATE:\s*(\S+)/){
	    $pkg->{fsample} = $1;
	}elsif(/PP:\s*(\S+)\s+\(sec\)/){
	    $pkg->{pp_sec} = $1;
	}elsif(/INTG_SEC:\s*(\S+)\s+\(sec\)/){
	    $pkg->{integ_sec} = $1;
	}elsif(/NPP:\s*(\S+)/){
	    $pkg->{npp} = $1;
	}elsif(/PRC_HOST\s*:/){
	    unless(m!PRC_HOST\s*:\s*(\w+)\s+PRC_DATE\s*:(\d{4}/\d{3})\s+([\d:,.]+)\s+COUT_FILE\s*:\s*(\S+)!){
		print STDERR "Error in SB_kombfmt::Read(): PRC_HOST format is unexpected\n";
		print STDERR "line = $_\n";
		exit(1);
	    };
	    my $host1 = $1;
	    my @tmdat1 = ($2, $3);
	    my $cfname =$4;
	    if(defined($pkg->{prc_host})){
		push(@{$pkg->{prc_host}}, ($host1));
	    }else{
		my @lst = ($host1);
		$pkg->{prc_host} = \@lst;
	    }
	    my $tm1 = new Time_lib;
	    $tm1->Set_time_strydhms(@tmdat1);
	    if(defined($pkg->{prc_time})){
		push(@{$pkg->{prc_time}}, ($tm1));
	    }else{
		my @lst = ($tm1);
		$pkg->{prc_time} = \@lst;
	    }

	    if(defined($pkg->{cout_file})){
		push(@{$pkg->{cout_file}}, ($cfname));
	    }else{
		my @lst = ($cfname);
		$pkg->{cout_file} = \@lst;
	    }
	}elsif(/NCH\s*:\s*(\S+)/){
	    $pkg->{nch} = $1;
	}elsif(/FRING_AMP\s*:\s*(\S+.+)$/){
	    my @arr = split(/\s+/,$1);
	    $pkg->{fring_amp} = \@arr;
	}elsif(/FRING_PHS\s*:\s*(\S+.+)$/){
	    my @arr = split(/\s+/,$1);
	    $pkg->{fring_phs} = \@arr;
	}elsif(/FREQ_TABL\s*:/){
	    my (@frq, @pcalf, @ulsb);
	    for(my $i=0; $i < $nch; $i++){
		my $line = <$in>;
		$line =~/\d+:\s*(\S+)\s+(\S+)\s+(\S+)/;
		push(@frq,($1));
		push(@pcalf,($2));
		push(@ulsb,($3));
	    }
	    $pkg->{rfrq} = \@frq;
	    $pkg->{pcalf} = \@pcalf;
	    $pkg->{ulsb} = \@ulsb;
	}elsif(/Freq_GCM\s*:\s*(\S+)\s*AMBG:\s*(\S+)/){
	    $pkg->{gcmfrq} = $1;
	    $pkg->{ambg} = $1;
	}elsif(/F_mean\s*:\s*(\S+)\s*BW_effectv:\s*(\S+)/){
	    $pkg->{f_mean} = $1;
	    $pkg->{bw_effect} = $2;
	}elsif(/FINE_AMPLITUDE\s*:\s*(\S+)\s+PHASE:\s*(\S+)\s*SNR:\s*(\S+)/){
	    $pkg->{fine_amp} = $1;
	    $pkg->{fine_phs} = $2;
	    $pkg->{fine_snr} = $3;
	}elsif(/FINE_RESD\S+:\s*(\S+\s+\S+)/){
	    my @fine_rsd = split(/\s+/,$1);
	    $pkg->{fine_rsd} = \@fine_rsd;
	}elsif(/CORAS_RESD\s*:\s*(\S+\s+\S+)/){
	    my @cors_rsd = split(/\s+/,$1);
	    $pkg->{corase_rsd} = \@cors_rsd;;
	}elsif(/APRIORI_DELAY\S+:\s*(\S+)\s+RATE.+:(\S+)/){
	    $pkg->{apri_del} = $1;
	    $pkg->{apri_rat} = $2;
	}elsif(/DELAY_RESID.+:(\S+)\s+RATE.+:(\S+)/){
	    my @rsd = ($1, $2);
	    $pkg->{del_rsd} = \@rsd;
	}elsif(/SNGL_BND_DEL_.+:(\S+)\s+RATE.+:(\S+)/){
	    my @sngl = ($1,$2);
	    $pkg->{sngl_delay} = \@sngl;
	}elsif(/GROUP_DELAY_.+:(\S+)\s+RATE.+:(\S+)/){
	    my @grp_del = ($1,$2);
	    $pkg->{grp_delay} = \@grp_del;
	}
    }


}

1;
