# @Version: $Id: Spl_mdl.pm 116 2017-01-14 04:46:00Z vlbi $
#
##
package Spl_mdl;
use Exporter;
use Carp;

@ISA = qw(Exporter);
# @EXPORT = qw(Read StnXYZ Stnames);

use Time_lib;

BEGIN{
    my @keywlist = ( "Data base", "UT1-TAI", "hi-freq variations", "Baseline Statistics",
		     "Residuals from", "Flyby Station Cals", "Station positions.",
		     "Source Statistics", "Atmosphere Constraint Statistics",
		     "Gradient Constraint Statistics","Baseline information",
		     "Clock Constraint Statistics", "Parameter adjustments",
		     "Corrected Reduced Chi-Square");

}

sub new ($){
    my $pkg = shift;
    my $this = {
# 	dbname => undef,
# 	UT1_TAI => undef,
# 	epoch => undef,
# 	dUT1err => undef,
    };
    bless $this;
    $this;
}

sub Get_baselineinfo($$){
    my $pkg= shift;
    my $in = shift;
#    my $p = caller;
#    my $in = $p . "::" . $in1;

    my $line;
    for($i=0; $i<5; $i++){$line = <$in>;}
    $ok =1;
    while($ok){
	if($line =~m!(\S+)\s+\d+\s+to (\S+)\s+\d+\s+([\d.]+)\s+([\d.]+)!){
	    my $base = join("-",($1,$2));
	    my $val = $3*1.e-3; $err = $4 * 1.e-3;
	    my %baseline;
	    %baseline = %{$pkg->{BaselineInfo}} if(defined(%{$pkg->{BaselineInfo}}));

	    my @val = ($val, $err);
	    $baseline{$base} = \@val;
	    $pkg->{BaselineInfo} = \%baseline;
	    last if(eof($in));
	    $line = <$in>;
	    next;
	}else{
	    #    printf STDERR "E Spl_mdl::Read(): Baseline info unmached: $line\n";
	    # my $found =0;
	    # foreach $k (@keywlist){
	    # 	if($line =~/$k/){
	    # 	    $ok=0;
	    # 	    $found=1;
	    # 	    last;}
	    # }
	    # $line =<IN> if( $found == 0 && !eof(IN) );		    
	    if($line !~/\S+/ || eof($in)){$ok=0;}
	    else{ $line =<$in>; }
	}
    }
    return  $line;
}

sub Get_AtmConst($$){
    my $pkg= shift;
    my $in = shift;
#    my $p = caller;
#    my $in = $p . "::" . $in1;

    my $line = <$in>;
    my (@stname);
    my $ok=1;
    while(!eof($in) && ($ok == 1)){
	$line =~/^\s*/;
	$line = $' ; #';
	
	if($line =~m!\d+.\s+(\S+)\s+Input\s+([\d.]+)\s+ps/h RMS\s+([\d.]+)\s+ps/h NRMS\s+([\d.]+)\s+share\s+([\d.]+)\s+count\s+([\d]+)!)
	{
	    my $stn = $1;
	    my %cns;
	    my %atmcns;
	    %atmcns = %{$pkg->{AtmConst}} if(defined( %{$pkg->{AtmConst}})) ;
	    $cns{Input} = $2;
	    $cns{RMS} = $3;  # ps/h
	    $cns{NRMS} = $4; 
	    $cns{share} = $5;
	    $cns{count} = $6;
	    $atmcns{$stn}=\%cns;
	    $line =<$in>;		
	    $pkg->{AtmConst} = \%atmcns;
	}elsif($line =~m!Overall\s+RMS\s+([\d.]+)\s+ps/h\s+NRMS\s+([\d.]+)\s+share\s+([\d.]+)\s+count\s+([\d]+)!){
	    my %cns;
	    my %atmcns;
	    %atmcns = %{$pkg->{AtmConst}} if(defined( %{$pkg->{AtmConst}})) ;
	    $cns{RMS} = $1;  # ps/h
	    $cns{NRMS} = $2; 
	    $cns{share} = $3;
	    $cns{count} = $4;
	    $atmcns{Overall}=\%cns;
	    $pkg->{AtmConst} = \%atmcns;
	    $line =<$in>;		    
	}else{
	    if($line !~/\S+/ || eof($in)){$ok=0;}
	    else{ $line =<$in>; }
	    # my $found =0;
	    # foreach $k (@keywlist){
	    # 	if($line =~/$k/){
	    # 	    $ok=0;
	    # 	    $found=1;
	    # 	    last;}
	    # }
	    # $line =<$in> if( $found == 0);		    
	}
    } # while loop
    return $line;
}

sub Get_GradConst($$){
    my $pkg= shift;
    my $in = shift;
#    my $p = caller;
#    my $in = $p . "::" . $in1;

    $line = <$in>;
    my (@stname);
    my $ok=1;
    while(!eof($in) && ($ok == 1)){
	$line =~/^\s*/;
	$line = $' ; #';
	
	if($line =~m!\d+.\s+(\S+)\s+Input\s+([\d.]+)\s+mm/d RMS\s+([\d.]+)\s+mm/d NRMS\s+(\S+)\s+share\s+([\d.]+)\s+count\s+([\d]+)!)
	{
	    my $stn = $1;
	    my %cns;
	    my %atmcns;
	    %atmcns = %{$pkg->{GradConst}} if(defined( %{$pkg->{GradConst}})) ;
	    $cns{Input} = $2;
	    $cns{RMS} = $3;  # ps/h
	    $cns{NRMS} = $4; 
	    $cns{share} = $5;
	    $cns{count} = $6;
	    $atmcns{$stn}=\%cns;
	    $line =<$in>;		
	    $pkg->{GradConst} = \%atmcns;
	}elsif($line =~m!Overall\s+RMS\s+([\d.]+)\s+mm/d NRMS\s+(\S+)\s+share\s+([\d.]+)\s+count\s+([\d]+)!){
	    my %cns;
	    my %atmcns;
	    %atmcns = %{$pkg->{GradConst}} if(defined( %{$pkg->{GradConst}})) ;
	    $cns{RMS} = $1;  # ps/h
	    $cns{NRMS} = $2; 
	    $cns{share} = $3;
	    $cns{count} = $4;
	    $atmcns{Overall}=\%cns;
	    $pkg->{GradConst} = \%atmcns;
	    $line =<$in>;		    
	}else{
	    if($line !~/\S+/ || eof($in)){$ok=0;}
	    else{ $line =<$in>; }
	    # my $found =0;
	    # foreach $k (@keywlist){
	    # 	if($line =~/$k/){
	    # 	    $ok=0;
	    # 	    $found=1;
	    # 	    last;}
	    # }
	    # $line =<$in> if( $found == 0);		    
	}
    } # while loop
    return $line;

}

sub Get_ClkConst($$){
    my $pkg= shift;
    my $in = shift;
#    my $p = caller;
#    my $in = $p . "::" . $in1;

    $line = <$in>;
    my ( @stname );
    my $ok=1;
    while(!eof($in) && ($ok == 1)){
	$line =~/^\s*/;
	$line = $' ; # ';
	
	if($line =~m!\d+.\s+(\S+)\s+Input\s+([\d.]+\s+D[-+\d]+)\s+RMS\s+([\d.]+\s+D[-+\d]+)\s+NRMS\s+([\d.]+)\s+share\s+([\d.]+)\s+count\s+([\d]+)!)
	{
	    my $stn = $1;
	    my %cns;
	    my %clkcns;
	    %clkcns = %{$pkg->{ClkConst}} if(defined($pkg->{ClkConst}));
	    $cns{Input} = $2;
	    $cns{RMS} = $3;  # ps/h
	    $cns{NRMS} = $4; 
	    $cns{share} = $5;
	    $cns{count} = $6;
	    $cns{Input} =~s/ D/e/;
	    $cns{RMS} =~s/ D/e/;
	    $clkcns{$stn}=\%cns;
	    $line =<$in>;		
	    $pkg->{ClkConst} = \%clkcns;
	}elsif($line =~m!Overall\s+RMS\s+([\d.]+\s+D[-+\d]+)\s+NRMS\s+([\d.]+)\s+share\s+([\d.]+)\s+count\s+([\d]+)!){
	    my %cns1;
	    my %clkcns;
	    %clkcns = %{$pkg->{ClkConst}} if(defined($pkg->{ClkConst}));
	    $cns1{RMS} = $1;  # 
	    $cns1{NRMS} = $2; 
	    $cns1{share} = $3;
	    $cns1{count} = $4;
	    $cns1{RMS} =~s/ D/e/;
	    $clkcns{Overall}=\%cns1;
	    $pkg->{ClkConst} = \%clkcns;
	    $line =<$in>;		    
	}else{
	    if($line !~/\S+/ || eof($in)){$ok=0;}
	    else{ $line =<$in>; }
	    # my $found =0;
	    # foreach $k (@keywlist){
	    # 	if($line =~/$k/){
	    # 	    $ok=0;
	    # 	    $found=1;
	    # 	    last;}
	    # }
	    # $line =<$in> if( $found == 0);		    
	}
    }
    return $line;
}

sub Get_Residual($$){
    my ($pkg,$in) = @_;
#    my $p = caller;
#    my $in = $p . "::" . $in1;

    my $line = <$in>; 
    $line = <$in>; $line = <$in>;
    ## obsdel, drsd, derr, rat, rrsd, rerr, elv[2], az[2], frq, QC, SNR,
    my $field = "A14A8A2A7A14A8A2A7A4A4A4A4A13A1A1A9";
    my (@iobs,@flag, @src,@st1,@st2, @tarr, @darr, @drsd,@derr,@rarr,@rrsd,@rerr,
	@el1,@el2,@az1,@az2,@snr,@qc,$ymd,$hms,$dat,@yms,@hms );
    my $cnt=0;
    while( !eof($in)){
#	if( $line =~m!(\d+)\s+(\w+\s*/\w+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)!){
	if( $line =~m!(\d+)(>?\s+)(\w+)\s*/(\w+)\s+(\S+)\s+(\d{4}.\d\d.\d\d)-(\d\d:\d\d:\d\d.\d)\s(.+)!){
	    $iobs[$cnt] = $1;
	    $st1[$cnt] = $3;
	    $st2[$cnt] = $4;
	    $src[$cnt] = $5;
	    $ymd = $6;
	    $hms = $7;
	    $dat = $8;
	    if($2 =~/>/){ $flag[$cnt]=0;}else{ $flag[$cnt]=1;}
	    @ymd = split(/[.]/,$ymd);
	    @hms = split(/:/,$hms);
	    $tarr[$cnt] = new Time_lib;
	    $tarr[$cnt]->Set_time_ymd(@ymd,@hms);
	    my @terms = unpack($field,$dat);
	    $darr[$cnt] = $terms[0] * 1.e-12;			       
	    for($i=0; $i<@terms; $i++){  $terms[$i] =0 if($terms[$i] =~/\*+/);}
	    $drsd[$cnt] = $terms[1] * 1.e-12;			       
	    $derr[$cnt] = $terms[3] * 1.e-12;			       		    
	    $rarr[$cnt] = $terms[4] * 1.e-15;			       
	    $rrsd[$cnt] = $terms[5] * 1.e-15;			       
	    $rerr[$cnt] = $terms[7] * 1.e-15;			       		    
	    $el1[$cnt] = $terms[8];	    $el2[$cnt] = $terms[9];
	    $az1[$cnt] = $terms[10];	    $az2[$cnt] = $terms[11];
	    $qc[$cnt] = $terms[13];	    $snr[$cnt] = $terms[15];
	    $cnt++;
#	    print STDERR "Warn: Deflagged data: $line.\n";
	    next;
	}elsif($line !~/\S+/  && $cnt>0){  last;
	}
	
    }continue{ # end of while
	$line =<$in>;
    }
    $pkg->{darr} = \@darr;
    $pkg->{drsd} = \@drsd;
    $pkg->{derr} = \@derr;
    $pkg->{rarr} = \@rarr;
    $pkg->{rrsd} = \@rrsd;
    $pkg->{rerr} = \@rerr;
    $pkg->{srcarr} = \@src;
    $pkg->{st1} = \@st1;
    $pkg->{st2} = \@st2;
    $pkg->{tarr} = \@tarr;
    $pkg->{el1} = \@el1;
    $pkg->{el2} = \@el2;
    $pkg->{az1} = \@az1;
    $pkg->{az2} = \@az2;
    $pkg->{QC}  = \@qc;
    $pkg->{snr} = \@snr;
    $pkg->{flag} = \@flag;
    return $line;
}

sub Check_XYZ_Stname($$){
    my $pkg=shift;    
    my $stname=shift;
    return -1 unless(defined($stname));
    my @keyarr = keys(%$pkg);
    my $nst = grep(/${stname}_xyz/,@keyarr);
    if($nst > 0){ return 1;}
    else{ return 0;}

}

## arg = argument 
## ixyz = 1,2,3 for XYZ
sub Get_XYZComp($$$){
    my ($pkg, $arg, $ixyz) = @_;
    my @terms = split(/\s+/,$arg);
    my $stname = $terms[1];
    my $kid = "${stname}_xyz";
    my $fact=1.e-3; # [mm] -> [m]
    my @pos;
    @pos = @{$pkg->{$kid}} if(defined( @{$pkg->{$kid}}));
    $pos[0] = $stname;
    $pos[$ixyz] = sprintf("%+.5f",$terms[6] *$fact); # XYZ
    $pos[$ixyz+3] = $terms[8] =~/\*\*\*/ ? $terms[8] : 
	sprintf("%+.5f",$terms[8] *$fact); # Adj
    $pos[$ixyz+6] = sprintf("%+.5f",$terms[12]*$fact); # Err
    $pkg->{$kid} = \@pos;
    return @pos;
}

## arg = argument 
## iuen = 1,2,3 for XYZ
sub Get_UENComp($$$){
    my ($pkg, $arg,$iuen) = @_;
    my $fld = "A2A4A8A1A5A1A4A1A2A1A4A20A3A15A3A19A3A19A3";
#    my @terms = split(/\s+/,$arg);
    my @terms2 = unpack($fld,$arg);
    my $stname = $terms2[2];
    my $kid = sprintf( "%s-uen",$stname);
    my $fact=1.e-3; # [mm] -> [m]
    my @uen; 
    if( defined( $pkg->{$kid} )){
	@uen = @{$pkg->{$kid}};
    }
    $uen[0] = $stname;
    $uen[$iuen] = sprintf("%+.5f",$terms2[11] *$fact); # XYZ
    $terms2[13] =0. if($terms2[13]=~/\*+/);
    $uen[$iuen+3] = sprintf("%+.5f",$terms2[13] *$fact);
    $uen[$iuen+6] = sprintf("%+.5f",$terms2[15]*$fact);
    $pkg->{"$kid"} = \@uen;
    return  @uen;
}

# sub Get_UENComp($$$){
#     my ($pkg, $arg,$iuen) = @_;
#     my @terms = split(/\s+/,$arg);
#     my $stname = $terms[0];
#     my $kid = "${stname}_uen";
#     my $fact=1.e-3; # [mm] -> [m]
#     my @uen; 
#     @uen = @{$pkg->{$kid}} if(defined( @{$pkg->{$kid}}));
#     $uen[0] = $stname;
#     $uen[$iuen] = sprintf("%+.5f",$terms[4] *$fact); # XYZ
#     $uen[$iuen+3] = sprintf("%+.5f",$terms[6] *$fact);
#     $uen[$iuen+6] = sprintf("%+.5f",$terms[10]*$fact);
#     $pkg->{$kid} = \@uen;
# }


sub Read($$){
    my $pkg = shift;
    my $fname = shift;

    my $infh;
    unless(open($infh, $fname)){
	print STDERR "Error File open failed $fname\n";
	return -1;
    }

    my @pos_stnames=();
    my $nitm=0;
    
#    my $mode = 0;  # 0: initial, 1: Station Pos.
    my (%stxyz, %stuen);
    my $line = <$infh>;

    while( !eof($infh) ){
#	if($line =~ /Corrected Reduced Chi-Square\s+([\d.]+)/){
#	print STDERR "test1 :$line \n";
	if($line =~ m!Corrected Reduced Chi-Square\s+(\S+)!){
	    my $kai = $1;    $pkg->{Kai2} = $kai;   $line = <$infh>;
	}elsif($line =~/Baseline information/){ # Baseline length
	    $line  = $pkg->Get_baselineinfo($infh);
	}elsif($line =~/Atmosphere Constraint Statistics/){
	    $line = $pkg->Get_AtmConst($infh);
	}elsif($line =~/Gradient Constraint Statistics/){
	    $line = $pkg->Get_GradConst($infh);
	}elsif($line =~/Clock Constraint Statistics/){
	    $line = $pkg->Get_ClkConst($infh);
	}elsif($line =~/Data base/){
	    $pkg->Set_DBname($line);   $nitm++;	    $line = <$infh>;
	}elsif($line =~/\d+\. UT1-TAI/){
	    $pkg->Set_UT1TAI($line);    $nitm++;    $line = <$infh>;
	}elsif($line =~/hi-freq variations/){
	    $line = $pkg->Set_HiFreqVar($infh);
	}elsif($line =~/Residuals from/){
	    $line = $pkg->Get_Residual($infh);
	}elsif($line =~/Flyby Station Cals/){ # Stations 
	    $line = $pkg->Set_Flyby($infh);    $nitm++;
	}elsif($line =~/Station positions.+epoch:\s*(\S+)/){
	    $pkg->Set_StnPosEpoch($line);   $line = <$infh>;  $nitm++;
	}elsif($line =~/(\d+.*X Comp.*)$/){ # X-component 
	    $pkg->Get_XYZComp($1,1);   
	    $line = <$infh>;     $nitm++;
#	    my @stnames = @{$pkg->{stnames}};
	}elsif($line =~/(\d+.*Y Comp.*)$/){ # Y-component 
	    $pkg->Get_XYZComp($1,2);    $line = <$infh>;     $nitm++;
	}elsif($line =~/(\d+.*Z Comp.*)$/){ # Z-component 
	    $pkg->Get_XYZComp($1,3);    $line = <$infh>;      $nitm++;
	}elsif($line =~/(\S+.*U Comp.*)$/){ # U-component 
	    $pkg->Get_UENComp($line,1);    $line = <$infh>;      $nitm++;
	}elsif($line =~/(\S+.*E Comp.*)$/){ # E-component 
	    $pkg->Get_UENComp($line,2);    $line = <$infh>;      $nitm++;
	}elsif($line =~/(\S+.*N Comp.*)$/){ # N-component 
	    $pkg->Get_UENComp($line,3);    $line = <$infh>;      $nitm++;
	}elsif($line =~/Data Type/){ # Statistics of total WRMS
	    $line = $pkg->Set_StatisWRMS($infh);
	} elsif($line =~/Baseline Statistics/){ # Baseline Statistics
	    $line = $pkg->Set_BaseStatis($infh);
	}else{
	    $line = <$infh>;
	}

    }

    seek($infh,0,0);
    $pkg->Read_Atm($infh);
    $pkg->Read_Clk($infh);

    close($infh);

    if($nitm <1){ return -1;}
    else { return 0; }
    
}



sub Set_BaseStatis($$){
    my ($pkg,$in) = @_;
    my ($line,%basestatis);
    for(my $i=0; $i<4; $i++){   $line = <$in>;     }
    my $cnt=0;
    
    while( !eof($in) && $line =~ /\S+/ ){
	$line =~/(\S+)\s*-(\S+)\s+(.+)/;
	my $base = "$1-$2";		
	my @darr = split(m![\s/]+!,$3 ); 
	next if(@darr < 3);
	$basestatis{$base} = \@darr;
    }continue{
	$line = <$in>;
    }
    $pkg->{basestatis} = \%basestatis;
    return $line;

}

sub Set_StatisWRMS($$){
    my ($pkg,$in) = @_;
    my ($line, %datstatis);
    for(my $i=0; $i<4; $i++){   $line = <$in>;     }
    my $cnt=0;
    while( !eof($in) && $line !~/----/ ){
	if($line =~/Delay[\s\t]+(\d+\s+.*)/){
	    my $del = $1;
	    my @terms = split(/\s+/,$del);
	    $datstatis{ndel} = $terms[0];
	    $datstatis{delwrms} = $terms[1];
	    $datstatis{delnrms} = $terms[3];
	    $datstatis{delchai2} = $terms[4];
	}elsif($line =~/Rate[\s\t]+(\d+\s+.*)/){
	    my $rat = $1;
	    my @terms = split(/\s+/,$rat);
	    $datstatis{nrat} = $terms[0];
	    $datstatis{ratwrms} = $terms[1];
	    $datstatis{ratnrms} = $terms[3];
	    $datstatis{ratchai2} = $terms[4];
	}elsif($line =~/Combined[\s\t]+(\d+\s+.*)/){
	    my $cmb = $1;
	    my @terms = split(/\s+/,$cmb);
	    $datstatis{ncmb} = $terms[0];
	    $datstatis{cmbnrms} = $terms[1];
	    $datstatis{cmbchai2} = $terms[2];
	}else{
	    print STDERR "E: Spl_mdl::Set_StatisWRMS():Unexpected line:[$line]\n";
	}
    }continue{
	$line = <$in>; 
    }
    $pkg->{datstatis} = \%datstatis;

    return $line;
    
}


sub Set_StnPosEpoch($$){
    my ($pkg,$line) = @_;
    unless($line =~/Station positions.+epoch:\s*(\S+)/){
	print STDERR "E Spl_mdl::Set_StnPosEpoch(): not mached:[$line] \n";
	return -1;
    }
    my $pos_epoch = $1;
    my @ymdhms = split(/[:,\-,.]+/,$pos_epoch);
    my $tm = new Time_lib;
    $tm->Set_time_ymd(@ymdhms);
    $pkg->{pos_Epoch} = $tm;
    return 0;
}



sub Set_UT1TAI($$){
    my $pkg = shift;
    my $line = shift;
    $line =~/\d+\. UT1-TAI\s+(.+)/;
    my @terms = split(/\s+/,$1); #');
    my @ymd = split(m!/!,$terms[2]);
    $ymd[0] += $ymd[0] <= 99 ? 1900 : 2000;
    my @hm = split(m!:!,$terms[3]);
    my $tm = new Time_lib;
    $tm->Set_time_ymd(@ymd,@hm,0);
    $pkg->{UT1_Epoch} = $tm;
    $pkg->{UT1_TAI} = $terms[4];
    $pkg->{dUT1err} = $terms[8];

}

## Set Station Names 
sub Set_Flyby($$){
    my ($pkg, $in) = @_;
    my  @stnames;
    my $line = <$in>;
    $line = <$in> while($line !~ /------/);    
    $line = <$in>; 
    while($line !~/-------------/){
	unless($line =~/(\S+)\s*:[\s\t]*\w+/){
	    chomp ($line);
#	    print STDERR "Warning: Station Name Mismatch:[$line]\n";
	}else{
	    push(@stnames,$1);
	}
	$line = <$in>; 
    }
    $pkg->{stnames} = \@stnames;

}

sub Set_HiFreqVar($$){
    my ($pkg,$in) = @_;
    for(my $i=0; $i<3; $i++){ $line = <$in>;}
    my @terms2 = split(/\s+/,$line);
    $pkg->{hfUT1_TAI} = $terms2[4];
    $pkg->{hfdUT1err} = $terms2[7];
    my $line = <$in>;
    return $line;
}

sub Set_DBname($$){
    my $pkg = shift;
    my $line = shift;
    $line =~/Data base\s+(.+)/;
    my $dbname = $1;
    chomp $dbname;
    $pkg->{dbname} = $dbname;

}

# If baseline is given, array reference is returned
# Othorwise  basestatis hash is returned.
sub BaseStatis($;$){
    my $pkg = shift;
    my $bl = shift;
    my $blstatis = $pkg->{basestatis};
    if(defined($bl)){
	return $blstatis->{$bl};
    }else{
	return $blstatis;
    }
}

#Atm Constraint
sub AtmConst( $ ){
    my $pkg=shift;
    my $atmcons = $pkg->{AtmConst};
    return $atmcons;
}

#Clock Constraint
sub ClkConst( $ ){
    my $pkg=shift;
    my $clkcons = $pkg->{ClkConst};
    return $clkcons;
}

# #Baseline Names
# Return Baseline names;
sub BLname( $ ){
     my $pkg=shift;
     my $blstat = $pkg->{basestatis};
     return keys(%{$blstat});
 }

sub DelStatis($){
    my $pkg = shift;
    my $dstat = $pkg->{datstatis};
    my @dstat = ($dstat->{ndel},$dstat->{delwrms},
		 $dstat->{delnrms},$dstat->{delchai2});
    return @dstat;
}

sub RatStatis($){
    my $pkg = shift;
    my $dstat = $pkg->{datstatis};
    my @dstat = ($dstat->{nrat},$dstat->{ratwrms},
		 $dstat->{ratnrms},$dstat->{ratchai2});
    return @dstat;
}

sub CmbStatis($){
    my $pkg = shift;
    my $dstat = $pkg->{datstatis};
    my @dstat = ($dstat->{ncmb},
		 $dstat->{cmbnrms},$dstat->{cmbchai2});
    return @dstat;
}


# sub Baseline($){
#     my $pkg = shift;
#     my $base = $pkg->{baselinelength};
#     return (%{$base});
# }

# sub DBName($){
#     my $pkg = shift;
#     my $blname = shift;
#     my $blstat = $pkg->{BaseStat};
#     my @bllist = keys(%{$blstat});
#     my $bdat = $blstat->{$blname};
    
#     my @ret;
#     if($bdat =~/NoData/){ 
# 	@ret= ("No Data");}
#     else{
# 	@ret = ($bdat->{UsedObs}, $bdat->{NObs},$bdat->{WRMS_Del},
# 		$bdat->{NRDs},$bdat->{NRD},$bdat->{WRMS_Rat},
# 		$bdat->{NRR},$bdat->{Del_RW},$bdat->{Rat_RW} );
#     }
#     return @ret;
# }

# # mode =1: yybbbddAA_vX
sub DBName($;$){
    my $pkg = shift;
    my $mode = shift;
    my $ret = $pkg->{dbname};
    if(defined($mode)){
	my @tms = split(/\s+/,$ret);
	$tms[0] =~s/\$//;
	$ret = sprintf("%s_v%d",$tms[0],$tms[2]) if( $mode == 1);
    }
    return $ret;
}

## mode=1;# yyyy/mm/dd-hh:mm:ss
## otherwise || mode=0;# yyyy mm dd hh mm ss
sub UT1Epoch($;$){
    my $pkg = shift;
    my $type = shift;
    my $tm1  = $pkg->{UT1_Epoch};
    if(!defined($type) || $type == 1){
	$tm1->Str_fmt3(1);
    }else{
	$tm1->Str_fmt3(0);
    }
}
## mode=0;# Time_lib;
## mode=1;# yyyy/mm/dd-hh:mm:ss
## mode=4;# yybbbdd e.g. 14Apr22
## otherwise || mode=0;# yyyy mm dd hh mm ss
sub PosEpoch($;$){
    my $pkg = shift;
    my $type = shift;
    my $tm1  = $pkg->{pos_Epoch};
    unless(defined($tm1)){
	return undef;
    }
    if(!defined($type) || $type == 1){
	$tm1->Str_fmt3(1);
    }elsif(!defined($type) || $type == 4){
	$tm1->Str_fmt3(4);
    }elsif($type == 0){
	return $tm1;
    }else{
	return $tm1->Str_fmt3(0);
    }
}

sub UT1_TAI($){
    my $pkg = shift;
    $pkg->{UT1-TAI};
	    }

sub UT1_UTC($){
    my $pkg = shift;
    my $dut = $pkg->{UT1-TAI};
    $dut += ${$pkg->{Epoch}}->TAI_UTC();
    return $dut;
	    }

sub dUT1_UTCerr($){
    my $pkg = shift;
    $pkg->{dUT1err};
		}

sub hfUT1_UTC($){
    my $pkg = shift;
    my $dut = $pkg->{hfUT1-TAI};
    $dut += ${$pkg->{Epoch}}->TAI_UTC();
    return $dut;
	      }


sub Tarr($){
    my $pkg = shift;
    @{$pkg->{tarr}};
}

sub SNRarr($){
    my $pkg = shift;
    @{$pkg->{snr}};
}

sub QCarr($){
    my $pkg = shift;
    @{$pkg->{QC}};
}

## 1 ->st1, Else -> St2:
sub Elarr($$){
    my ($pkg,$ist) = @_;
    if( $ist == 1){ return @{$pkg->{el1}}; }
    else{ return @{$pkg->{el2}}; }
}
## 1 ->st1, Else -> St2:
sub Azarr($$){
    my ($pkg,$ist) = @_;
    if( $ist == 1){ return @{$pkg->{az1}}; }
    else{ return @{$pkg->{az2}}; }
}


sub SrcArr($){
    my $pkg = shift;
    @{$pkg->{srcarr}};
}

sub DelArr($){
    my $pkg = shift;
    @{$pkg->{darr}};
}
sub RatArr($){
    my $pkg = shift;
    @{$pkg->{rarr}};
}

sub DelErr($){
    my $pkg = shift;
    @{$pkg->{derr}};
}
sub RatErr($){
    my $pkg = shift;
    @{$pkg->{rerr}};
}
sub FlagArr($){
    my $pkg = shift;
    @{$pkg->{flag}};
}


sub DelResidual($){
    my $pkg = shift;
    @{$pkg->{drsd}};
}

sub RatResidual($){
    my $pkg = shift;
    @{$pkg->{rrsd}};
}

# istn ==1 -> Station1 
# istn ==2 -> Station2 
sub DelStation($$){
    my ($pkg,$istn) = @_;
    if($istn == 1){ return @{$pkg->{st1}}; }
    elsif($istn == 2){ return @{$pkg->{st2}}; }
    else{ return undef;}
}

sub Stnames($){
    my $pkg = shift;
    # my @stlst = grep(/STN/,keys(%{$pkg}));
    # my @stns = map {$_ =~s/_STN//; $_} @stlst;
    my @stns = @{$pkg->{stnames}};
    return @stns;
}

sub Nstn($){
    my $pkg =shift;
    my $nstn = @{$pkg->{stnames}};
    return $nstn;
}

## Starr data is XYZ, AdjXYZ, ErrXYZ 
sub StnXYZ($){
    my $pkg = shift;
    my $sthash;
    my $i=0;
    my @stnames = @{$pkg->{stnames}};
    my $nstn = @stnames;

    for($i=0; $i<$nstn; $i++){
	my $s = sprintf "%s_xyz",$stnames[$i];
	$sthash = $pkg->{$s} if(defined($pkg->{$s}));
    }
    return @$sthash;
}

sub StnUEN($){
    my $pkg = shift;
    my %sthash;
    my $i=0;
    my @stnames = @{$pkg->{stnames}};
    my $nstn = @stnames;
    my $s;
    # for($i=0; $i<$nstn; $i++){
    # 	$s = sprintf "%s-uen",$stnames[$i];
    # 	$sthash{$s} = $pkg->{$s} if(defined($pkg->{$s}));
    # }
    foreach $s (grep(/uen/,keys(%{$pkg}))){
	$sthash{$s} = $pkg->{$s} 
    }

    return %sthash;
}

# sub BaseNames($){
#     my $pkg = shift;
#     my %baseinfo = %{$pkg->{BaselineInfo}};
#     my @blst = keys(%baseinfo);
#     return @blst;
# }

sub Baseline($$){
    my $pkg = shift;
    my $base = shift;
    my %baseinfo = %{$pkg->{BaselineInfo}};
    if(defined($baseinfo{$base})){
	return @{$baseinfo{$base}};
    }else{ return  (); }
}

sub Kai2($){
    my $pkg = shift;
    return $pkg->{Kai2};
}

sub PrintXYZ($){
    my $spl = shift;
    my $posEpoch = $spl->PosEpoch();
    printf "Position Epoch: %s \n",$posEpoch;
    foreach $s (grep(/xyz/,keys(%{$spl}))){
	my $val = $spl->{$s};
	printf " XYZ: %-10s %+13.5lf %+13.5lf %+13.5lf Err: %+8.5lf %+8.5lf %+8.5lf [mm]\n",
	$$val[0], $$val[1],$$val[2],$$val[3], $$val[7],$$val[8],$$val[9];
    }
}

sub PrintUEN($){
    my $spl = shift;
    my $posEpoch = $spl->PosEpoch();
    printf "Position Epoch: %s \n",$posEpoch;
    foreach $s (grep(/uen/,keys(%{$spl}))){
	my $val = $spl->{$s};
	printf " UEN: %-10s %+13.5lf %+13.5lf %+13.5lf Err: %+8.5lf %+8.5lf %+8.5lf [mm]\n",
	$$val[0], $$val[1],$$val[2],$$val[3], $$val[7],$$val[8],$$val[9];
    }
}

sub PrintBase($){
    my $spl = shift;
    my %base = $spl->Baseline();
    foreach $stn (keys(%base)){
	my $bl = $base{$stn};
	printf " Baseline: %-20s Length %s +/- %s [mm]\n", $stn, @{$bl} ;
    }
}

sub PrintAtmCnst(){
    my $spl = shift;
    my $acnst = $spl->{AtmConst};
    print "Atm Constraint \n";
    foreach $stn (keys(%{$acnst})){
	my $arr = $acnst->{$stn};
	if($stn =~/Overall/){
	    printf " Station: %-20s          RMS %s NRMS %s\n", $stn, @{$arr} ;
	}else{
	    printf " Station: %-20s Input %s RMS %s NRMS %s\n", $stn, @{$arr} ;
	}
    }
}

sub PrintClkCnst(){
    my $spl = shift;
    print "Clock Constraint \n";
    my $clkcnst = $spl->{ClkConst};
    foreach $stn (keys(%{$clkcnst})){
	my $arr = $clkcnst->{$stn};
	if($stn =~/Overall/){
	    printf " Station: %-20s          RMS %s NRMS %s\n", $stn, @{$arr} ;
	}else{
	    printf " Station: %-20s Input %s RMS %s NRMS %s\n", $stn, @{$arr} ;
	}
    }
}


sub Atm_param($$){
    my $pkg = shift;
    my $stn = shift;
    my $atmarr = $pkg->{atm};
    return $atmarr->{$stn};
}

sub Clk_param($$){
    my $pkg = shift;
    my $stn = shift;
    my $clkarr = $pkg->{clk};
    return $clkarr->{$stn};
}


# sub Read($$){
#     my $pkg = shift;
#     my $fname = shift;

#     my $infh;
#     unless(open($infh, $fname)){
# 	print STDERR "Error File open failed $fname\n";
# 	return -1;
#     }
    
#     my $nitm=0;
    
# #    my $mode = 0;  # 0: initial, 1: Station Pos.
#     my (%stxyz, %stuen);
#     my @keywlist = ( "Data base", "UT1-TAI", "hi-freq variations", "Baseline Statistics",
# 		       "Residuals from", "Flyby Station Cals", "Station positions.",
# 		     "Source Statistics", "Atmosphere Constraint Statistics",
# 		     "Gradient Constraint Statistics","Baseline information",
# 		     "Clock Constraint Statistics", "Parameter adjustments",
# 		     "Corrected Reduced Chi-Square");
#     my $line = <$infh>;

#     while( !eof($infh) ){
# #	if($line =~ /Corrected Reduced Chi-Square\s+([\d.]+)/){
# #	print STDERR "test1 :$line \n";
# 	if($line =~ m!Corrected Reduced Chi-Square\s+(\S+)!){
# 	    my $kai = $1;    $pkg->{Kai2} = $kai;   $line = <$infh>;
# 	}elsif($line =~/Baseline information/){ # Baseline length
# 	    $line  = $pkg->Get_baselineinfo($infh);
# 	}elsif($line =~/Atmosphere Constraint Statistics/){
# 	    $line = $pkg->Get_AtmConst($infh);
# 	}elsif($line =~/Gradient Constraint Statistics/){
# 	    $line = $pkg->Get_GradConst($infh);
# 	}elsif($line =~/Clock Constraint Statistics/){
# 	    $line = $pkg->Get_ClkConst($infh);
# 	}elsif($line =~/Data base/){
# 	    $pkg->Set_DBname($line);
# 	    $nitm++;	    $line = <$infh>;
# 	}elsif($line =~/\d+\. UT1-TAI/){
# 	    $pkg->Set_UT1TAI($line);
# 	    $nitm++;	    $line = <$infh>;
# 	}elsif($line =~/hi-freq variations/){
# 	    $line = $pkg->Set_HiFreqVar($infh);
# 	}elsif($line =~/Residuals from/){
# 	    $line = $pkg->Get_Residual($infh);
# 	}elsif($line =~/Flyby Station Cals/){ # Stations 
# 	    $line = $pkg->Set_flyby($infh);    $nitm++;
# 	}elsif($line =~/Station positions.+epoch:\s*(\S+)/){
# #	    $mode =1; # Station Pos. mode
# 	    my $pos_epoch = $1;
# 	    my @ymdhms = split(/[:,\-,.]+/,$pos_epoch);
# 	    my $tm = new Time_lib;
# 	    $tm->Set_time_ymd(@ymdhms);
# 	    $pkg->{pos_Epoch} = $tm;
# 	    $line = <$infh>;
#       	    $nitm++;
# #	    next;
# 	}elsif($line =~/(\d+.*X Comp.*)$/){ # X-component 
# 	    $pkg->Get_XYZComp($1,1);
# 	    $line = <$infh>;
#       	    $nitm++;
# #	    my @stnames = @{$pkg->{stnames}};
# 	}elsif($line =~/(\d+.*Y Comp.*)$/){ # Y-component 
# 	    $pkg->Get_XYZComp($1,2);
# 	    $line = <$infh>;
#       	    $nitm++;
# 	}elsif($line =~/(\d+.*Z Comp.*)$/){ # Z-component 
# 	    $pkg->Get_XYZComp($1,3);
# 	    $line = <$infh>;
#       	    $nitm++;
# 	}elsif($line =~/(\S+.*U Comp.*)$/){ # U-component 
# 	    $pkg->Get_UENComp($1,1);
# 	    $line = <$infh>;
#       	    $nitm++;
# #	    next;
# 	}elsif($line =~/(\S+.*E Comp.*)$/){ # E-component 
# 	    $pkg->Get_UENComp($1,2);
# 	    $line = <$infh>;
#       	    $nitm++;
# #	    next;
# 	}elsif($line =~/(\S+.*N Comp.*)$/){ # N-component 
# 	    $pkg->Get_UENComp($1,3);
# 	    $line = <$infh>;
#       	    $nitm++;
# #	    next;
# 	}elsif($line =~/Data Type/){ # Statistics of total WRMS
# 	    my %datstatis;
# 	    $line = <$infh>; $line = <$infh>; $line = <$infh>; $line = <$infh>; 
# 	    my $cnt=0;
	    
# 	    while( !eof($infh) && $line !~/----/ ){
# 		if($line =~/Delay[\s\t]+(\d+\s+.*)/){
# 		    my $del = $1;
# 		    my @terms = split(/\s+/,$del);
# 		    $datstatis{ndel} = $terms[0];
# 		    $datstatis{delwrms} = $terms[1];
# 		    $datstatis{delnrms} = $terms[3];
# 		    $datstatis{delchai2} = $terms[4];
# 		}elsif($line =~/Rate[\s\t]+(\d+\s+.*)/){
# 		    my $rat = $1;
# 		    my @terms = split(/\s+/,$rat);
# 		    $datstatis{nrat} = $terms[0];
# 		    $datstatis{ratwrms} = $terms[1];
# 		    $datstatis{ratnrms} = $terms[3];
# 		    $datstatis{ratchai2} = $terms[4];
# 		}elsif($line =~/Combined[\s\t]+(\d+\s+.*)/){
# 		    my $cmb = $1;
# 		    my @terms = split(/\s+/,$cmb);
# 		    $datstatis{ncmb} = $terms[0];
# 		    $datstatis{cmbnrms} = $terms[1];
# 		    $datstatis{cmbchai2} = $terms[2];
# 		}else{
# 		    print STDERR "E: Unexpected line:$line\n";
# #		    next;
# 		}
# 		$line = <$infh>; 
# 	    }
# 	    $pkg->{datstatis} = \%datstatis;
# 	    $nitm++;
# #	    next;
# 	} elsif($line =~/Baseline Statistics/){ # Baseline Statistics
# 	    my %basestatis;
# 	    $line = <$infh>; $line = <$infh>; $line = <$infh>; $line = <$infh>; 
# 	    my $cnt=0;
	    
# 	    while( !eof($infh) && $line =~/\S+/ ){
# 	 	$line =~/(\S+\s*-\S+)\s+/;
# 	 	my $base = $1;		
# 	 	my @darr = split(m![\s/]+!,$'); # ');
# 	 	next if(@darr < 3);
# 	 	$basestatis{$base} = \@darr;
# 	    }continue{
# 	 	$line = <$infh>;
# 	    }
# 	    $pkg->{basestatis} = \%basestatis;
# 	    $nitm++;

# 	}else{
# 	    $line = <$infh>;
# 	}


# # 	}elsif($line =~/Baseline Statistics/){
# # 	    for( $i=0; $i<4; $i++){ $line = <$infh>;}
# # 	    my (@blname, %blstat);
# # 	    my $ok=1;
# # 	    while(!eof($infh) && ($ok == 1)){
# # 		$line =~/^\s*/;
# # 		$line = $' ; #';
# # 		if($line =~m!(\S+)-(\S+)\s+(\d+)/([\s\d]+)\s+(\d+)\s+([\d.]+)\s+([\d.]+)\s+([\d]+)\s+([\d.]+)\s+([\d]+)\s+([\d.]+)!)
# # 		{
# # 		    my $base = join("-",($1,$2));
# # 		    my %bldat;
# # 		    $bldat{UsedObs} = $3;
# # 		    $bldat{NObs} = $4;
# # 		    $bldat{WRMS_Del} = $5; # ps
# # 		    $bldat{NRDs} = $6;
# # 		    $bldat{NRD} = $7;
# # 		    $bldat{WRMS_Rat} = $8; # fs/s
# # 		    $bldat{NRR} = $9;
# # 		    $bldat{Del_RW} = $10; # ps
# # 		    $bldat{Rat_RW} = $11; # fs/s
# # 		    $blstat{$base}=\%bldat;
# # # 		    push(@blname,$base);
# # # 		    push(@blstat,\%bldat);
# #  		    $line =<$infh>;		
# # # 		    $pkg->{Blname} = \@blname;    
# # 		    $pkg->{BaseStat} = \%blstat;
# # 		}elsif($line =~m!([\S]+)\s*-(\S+)\s+No Data!){
# # 		    my $base1 = join("-",($1,$2));		
# # 		    $blstat{$base1}="NoData";
# # # 		    push(@blname,$base1);
# # # 		    push(@blstat,"NoData");
# # # 		    $pkg->{Blname} = \@blname;
# # 		    $pkg->{BaseStat} = \%blstat;
# # 		    $line =<$infh>;		    
# # 		}else{
# # 		    my $found1 =0;
# # 		    foreach $k (@keywlist){
# # 			if($line =~/$k/){
# # 			    $ok=0;
# # 			    $found1=1;
# # 			    last;}
# # 		    }
# # 		    if( $found1 == 0){$line =<$infh> ;}
# # 		    else{ last;}
# # 		}		
# # 	    }
# # 	    next;
# 	# }elsif($line =~/Atmosphere Constraint Statistics/){ # Atm Const
# 	#     $line = &Get_AtmConst
# 	#     my (%constr);
# 	#     $line = <$infh>; 
# 	#     my $cnt=0;
# 	#     while( $line =~/(\S+.*)$/ ){
# 	# 	my $dat = $1;
# 	# 	if($dat =~/\d+.\s+(\S+)\s*Input\s+(\S.*)$/){
# 	# 	    $stname = $1;
# 	# 	    $dat = $2;
# 	# 	    my @terms = split(/\s+/,$dat);
# 	# 	    my @cnsarr = ($terms[0],$terms[3],$terms[6]);
# 	# 	    $constr{$stname}=\@cnsarr;
# 	# 	}elsif($dat =~/Overall\s+RMS\s+(\S.*)$/){
# 	# 	    $dat = $1;
# 	# 	    my @terms = split(/\s+/,$dat);
# 	# 	    my @cnsarr = ($terms[0],$terms[3],$terms[5]);
# 	# 	    $constr{Overall}=\@cnsarr;
# 	# 	}else{
# 	# 	    print STDERR "E: Unexpected line:$line\n";
# 	# 	    next;
# 	# 	}
# 	# 	$line = <$infh>; 
# 	#     }
# 	#     $pkg->{AtmConst} = \%constr;
# 	#     $nitm++;
# 	#     next;
# 	# }elsif($line =~/Clock Constraint Statistics/){ # Clk Const
# 	#     my (%constr);
# 	#     $line = <$infh>; 
# 	#     my $cnt=0;
# 	#     while( $line =~/(\S+.*)$/ ){
# 	# 	my $dat = $1;
# 	# 	if($dat =~/\d+.\s*\s(\S+)\s*Input\s+(\S.*)$/){
# 	# 	    $stname = $1;
# 	# 	    $dat = $2;
# 	# 	    my @terms = split(/\s+/,$dat);
# 	# 	    my @cnsarr = ();
# 	# 	    $terms[1] =~/D([+--\d]+)/; $cnsarr[0] = $terms[0] * 10**($1);
# 	# 	    $terms[4] =~/D([+--\d]+)/; $cnsarr[1] = $terms[3] * 10**($1);
# 	# 	    $cnsarr[2] = $terms[6];
# 	# 	    $constr{$stname}=\@cnsarr;
# 	# 	}elsif($dat =~/Overall\s+RMS\s+(\S.*)$/){
# 	# 	    $dat = $1;
# 	# 	    my @terms = split(/\s+/,$dat);
# 	# 	    my @cnsarr = ();
# 	# 	    $terms[1] =~/D([+--\d]+)/; $cnsarr[0] = $terms[0] * 10**($1);
# 	# 	    $cnsarr[1] = $terms[3];
# 	# 	    $constr{Overall}=\@cnsarr;
# 	# 	}else{
# 	# 	    print STDERR "E: Unexpected line:$line\n";
# 	# 	    next;
# 	# 	}
# 	# 	$line = <$infh>; 
# 	#     }
# 	#     $pkg->{ClkConst} = \%constr;
# 	#     $nitm++;
# 	#     next;
# 	# }elsif($line =~/Baseline information for run/){ # Baseline
# 	#     my %blength;
# 	#     $line = <$infh>; $line = <$infh>; $line = <$infh>; $line = <$infh>; $line = <$infh>; 
# 	#     my $cnt=0;
# 	#     while( !eof($infh) && $line =~/(\S+.*)$/ ){
# 	# 	my $dat = $1;
# 	# 	if($dat =~/(\w+)\s+\d+\s+to\s+(\w+)\s+\d+\s+([\d.]+)\s+([\d.]+)/){
# 	# 	    my $basename = "$1-$2";
# 	# 	    my @bline = ($3,$4);
# 	# 	    $blength{$basename}=\@bline;
# 	# 	}else{
# 	# 	    print STDERR "E: Unexpected line:$line\n";
# 	# 	    next;
# 	# 	}
# 	# 	$line = <$infh>; 
# 	#     }
# 	#     $pkg->{baselinelength} = \%blength;
# 	#     $nitm++;
# 	#     next;
#     }
#     close($infh);

#     if($nitm <1){ return -1;}
#     else { return 0; }
# }

sub Atm($$$){
    my $pkg = shift;
    my $stn = shift;
    my $tm1  = shift;
    my $atmarr = $pkg->{atm};
    my $atmdat = $atmarr->{$stn};
    unless(defined($atmdat)){
	print STDERR "W Spl_mdl::Atm(): No Atm data for Stn[$stn] \n";
	return -1;
    }
    
    my $tarr = $atmdat->{tarr};
    my $atm = $atmdat->{atm};
    my $atmerr = $atmdat->{atmerr};
    my $atmord = $atmdat->{atmord};

    my $ncff = @{$atm};
    my @tm;
    my @cff = (0,0,0); # Up to 2nd order at present
    for(my $i=0; $i<$ncff; $i++){
	if($tarr[$i] < $tm1){
	    if($atmord[$i] == 0){
		$tm[0] = $tarr[$i];
		$cff[0] = $atm[$cnt];
	    }elsif($atmord[$i] == 1){
		$tm[1] = $tarr[$i];
		$cff[1] = $atm[$cnt];
	    }elsif($atmord[$i] == 2){
		$tm[2] = $tarr[$i];
		$cff[2] = $atm[$cnt];
	    }else{
		print STDERR "E Spl_mdl::Atm(): order[$atmord[$i]] is not supported \n";
	    }
	}
    }
    
    my @atmcmp = (0,0,0);
    $atmcmp[0] = $cff[0];
    if( defined($tm[1])){
	my $dt = $tm1 - $tm[1];
	$atmcmp[1] = $cff[1] * $dt ;
    }
    if( defined($tm[2]) ){
	my $dt = $tm1 - $tm[2];
	my $dtd = $dt/86400.;
	$atmcmp[2] = $cff[2] * $dt * $dtd ;
    }
    
    return $atmcmp[0] +$atmcmp[1] +$atmcmp[2];
}



sub Clk($$$){
    my ($pkg, $stn,$tm1) = @_;
    my $clkdat = $pkg->{clk}->{$stn};
    unless(defined($clkdat)){
	print STDERR "W Spl_mdl::Clk(): No Clk data for Stn[$stn] \n";
	return -1;
    }
    
    my $tarr = $clkdat->{tarr};
    my $clk = $clkdat->{clk};
    my $clkerr = $clkdat->{clkerr};
    my $clkord = $clkdat->{clkord};

    my $ncff = $#$clk +1;
    my @tm;
    my @cff = (0,0,0); # Up to 2nd order at present
    my @cerr= (0,0,0); # Up to 2nd order at present
    for(my $i=0; $i<$ncff; $i++){
	if( $$tarr[$i] <= $tm1){
	    if( $$clkord[$i] == 0){
		$tm[0] = $$tarr[$i];
		$cff[0] = $$clk[$i];
		$cerr[0] = $$clkerr[$i];
	    }elsif($$clkord[$i] == 1){
		$tm[1] = $$tarr[$i];
		$cff[1] = $$clk[$i];
		$cerr[1] = $$clkerr[$i];
	    }elsif($$clkord[$i] == 2){
		$tm[2] = $$tarr[$i];
		$cff[2] = $$clk[$i];
		$cerr[2] = $$clkerr[$i];
	    }else{
		print STDERR "E Spl_mdl::Clk(): order[$$clkord[$i]] is not supported \n";
	    }
	}
    }

    my @clkcmp = (0,0,0);
    my @clkcmperr = (0,0,0);
    $clkcmp[0] = $cff[0];
    $clkcmperr[0] = $cerr[0];
    
    if( defined($tm[1])){
	my $dt = $tm1 - $tm[1];
	$clkcmp[1] = $cff[1] * $dt ;
	$clkcmperr[1] = $cerr[1]* $dt ;
    }
    if( defined($tm[2])){
	my $dt = $tm1 - $tm[2];
	my $dtd = $dt/86400.;
	$clkcmp[2] = $cff[2] * $dt * $dtd;
#	$clkcmp[2] = $cff[2] * $dt * $dtd *0.5;
	$clkcmperr[2] = $cerr[2]* $dt * $dtd;
    }
    my $val = $clkcmp[0] +$clkcmp[1] +$clkcmp[2];

    # my $err = sqrt($clkcmperr[0]*$clkcmperr[0] + 
    # 		   $clkcmperr[1]*$clkcmperr[1] +
    # 		   $clkcmperr[2]*$clkcmperr[2]);
    my $err = $clkcmperr[0];
    return ($val, $err);
    

}

# Interpolation between CL0
sub Clk_int($$$){
    my ($pkg, $stn,$tm1) = @_;
    my $clkdat = $pkg->{clk}->{$stn};
    unless(defined($clkdat)){
	print STDERR "W Spl_mdl::Clk(): No Clk data for Stn[$stn] \n";
	return -1;
    }
    
    my $tarr = $clkdat->{tarr};
    my $clk = $clkdat->{clk};
    my $clkerr = $clkdat->{clkerr};
    my $clkord = $clkdat->{clkord};

    my $ncff = $#$clk +1;
    my @tm;
    my @cff = (0,0,0); # Up to 2nd order at present
    my @cerr= (0,0,0); # Up to 2nd order at present
    my $aft=0;
    for(my $i=0; $i<$ncff; $i++){
	if( $$tarr[$i] <= $tm1){
	    if( $$clkord[$i] == 0){
		$tm[0] = $$tarr[$i];
		$cff[0] = $$clk[$i];
		$cerr[0] = $$clkerr[$i];
	    }elsif($$clkord[$i] == 1){
		$tm[1] = $$tarr[$i];
		$cff[1] = $$clk[$i];
		$cerr[1] = $$clkerr[$i];
	    }elsif($$clkord[$i] == 2){
		$tm[2] = $$tarr[$i];
		$cff[2] = $$clk[$i];
		$cerr[2] = $$clkerr[$i];
	    }else{
		print STDERR "E Spl_mdl::Clk(): order[$$clkord[$i]] is not supported \n";
	    }
	}
	if( $$tarr[$i] > $tm1 && $aft ==0){
	    if( $$clkord[$i] == 0){
		$tm[3] = $$tarr[$i];
		$cff[3] = $$clk[$i];
		$cerr[3] = $$clkerr[$i];
		$aft=1;
	    }
	}
    }

    my @clkcmp = (0,0,0);
    my @clkcmperr = (0,0,0);
    if($aft){
	my $dt1 = $tm[3] - $tm[0];
	my $dt2 = $tm1 - $tm[0];
	$clkcmp[0] = ($cff[3]-$cff[0])/$dt1*$dt2 + $cff[0];
	$clkcmperr[0] = $cerr[0];
    }else{
	$clkcmp[0] = $cff[0];
	$clkcmperr[0] = $cerr[0];
    }
    if( defined($tm[1])){
	my $dt = $tm1 - $tm[1];
	$clkcmp[1] = $cff[1] * $dt ;
	$clkcmperr[1] = $cerr[1]* $dt ;
    }
    if( defined($tm[2])){
	my $dt = $tm1 - $tm[2];
	my $dtd = $dt/86400.;
	$clkcmp[2] = $cff[2] * $dt * $dtd;
#	$clkcmp[2] = $cff[2] * $dt * $dtd *0.5;
	$clkcmperr[2] = $cerr[2]* $dt * $dtd;
    }

    my $val = $clkcmp[0] +$clkcmp[1] +$clkcmp[2];

    # my $err = sqrt($clkcmperr[0]*$clkcmperr[0] + 
    # 		   $clkcmperr[1]*$clkcmperr[1] +
    # 		   $clkcmperr[2]*$clkcmperr[2]);
    my $err = $clkcmperr[0];
    return ($val, $err);
    

}

sub Read_Atm($$){
    my ($pkg, $in) = @_;
    my @stns = $pkg->Stnames();
    my %atmarr;
    foreach $st (@stns){
	my %atmdat;
	my (@tarr, @atmord, @atm, @atmerr);
	seek($in,0,0);
	my $line=<$in>;
	$line= <$in> while( $line !~/Parameter adjustments for/ );
	$line= <$in>; 
	my $cnt=0;
	while( $cnt >= 0 && !eof($in)){
	    if($line =~ m!\d+\.\s+$st\s+[aA][tT]\s+(.+)!){
		my $tmp = $1;
		if($tmp =~ m!(\d)\s+(\d\d)/(\d\d)/(\d\d) (\d\d):(\d\d)[\s\t]+([-\d.]+) \w+[\s\t]+([-\d.]+) \w+!){
		    $atmord[$cnt] = $1;
		    my @ymdhms = ($2 + 2000,$3,$4,$5,$6,0);
		    $atm[$cnt] = $7 * 1.e-12;
		    $atmerr[$cnt] = $8 * 1.e-12;
		    $tarr[$cnt] = new Time_lib;
		    $tarr[$cnt]->Set_time_ymd(@ymdhms);
		    $cnt++;
		}else{
		    print STDERR "E Spl_mdl::Read_Atm(): Unexpected Atm Format:[$line]\n";
		    next;
		}
	    }else{ next;   }
	}continue{
	    $line = <$in>;
	    foreach my $kw (@keywlist){ $cnt=-1 if($line =~/$kw/);}
	}
	
	$atmdat{tarr} = \@tarr;
	$atmdat{atm} = \@atm;
	$atmdat{atmord} = \@atmord;
	$atmdat{atmerr} = \@atmerr;
	$atmarr{$st} = \%atmdat;
    }
    $pkg->{atm} = \%atmarr;
    return $line;
}

sub Read_Clk($$){
    my ($pkg, $in) = @_;
    my @stns = $pkg->Stnames();
    my %clkarr;

    foreach my $st (@stns){
	my %clkdat;
	my (@tarr, @clk, @clkerr, @clkord);
	seek($in,0,0);
	my $line = <$in>;
	$line= <$in> while( $line !~/Parameter adjustments for/ );
	$line= <$in>; 
	my $cnt=0;
	while( $cnt >= 0 && !eof($in) ){
	    if($line =~m!\d+\.\s+$st\s+[cC][lL]\s+(.+)!){
		my $tmp = $1;
		if($tmp =~m!(\d)\s+(\d\d)/(\d\d)/(\d\d) (\d\d):(\d\d)[\s\t]+([-\d.]+) \S+[\s\t]+([-\d.]+) \S+!){
		    $clkord[$cnt] = $1;
		    my @ymdhms = ($2 + 2000,$3,$4,$5,$6,0);
		    $clk[$cnt] = $7;
		    $clkerr[$cnt] = $8;
		    my $fact=1.e-9;
		    if( $clkord[$cnt] ==0){
			$fact=1.e-9;
		    }elsif( $clkord[$cnt] ==1){
			$fact=1.e-14;
		    }elsif( $clkord[$cnt] ==2){
			$fact=1.e-14;
		    }else{
			print STDERR "Spl_mdl::Read_Clk(): Clock order [$clkord[$cnt]] is not supported yet. \n";
			next;
		    }
		    $clk[$cnt] *= $fact;
		    $clkerr[$cnt] *= $fact;
		    $tarr[$cnt] = new Time_lib;
		    $tarr[$cnt]->Set_time_ymd(@ymdhms);
		    $cnt++;
		}else{
		    print STDERR "E Clock data line MisMached [$line]\n";
		}
	    }else{
		next;
	    }
	}continue{
	    $line = <$in>;
	    foreach my $kw (@keywlist){ $cnt=-1 if($line =~/$kw/);}
	}
	
	$clkdat{tarr} = \@tarr;
	$clkdat{clk} = \@clk;
	$clkdat{clkord} = \@clkord;
	$clkdat{clkerr} = \@clkerr;

	$clkarr{$st} = \%clkdat   if(@tarr > 0);
    }
    $pkg->{clk} = \%clkarr;
    return $line;
}


1;
