# @Version: $Id: TCPIP.pm 81 2016-01-21 10:56:01Z vlbi $
#
package TCPIP;
use strict "subs";
use Socket;
use Exporter;
@ISA=qw(Exporter);
@EXPORT = qw(tcp_server tcp_client);

BEGIN{
}

#
#  Usage:  tcp_server(HANDLE [, PORT=32001])
#

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}


sub Connect($$$){
    my $pkg=shift;
    my $hostname = shift;
    my $port = shift;

    my $sock;
    my $proto = getprotobyname('tcp');
    socket($sock, PF_INET, SOCK_STREAM, $proto);
#    print "port = $port\n";    
    my $portnum=$port;
    unless( $port =~ /^\d+/){
	$portnum = getservbyname($port, 'tcp');
	unless( $portnum =~ /^\d+/){
	    print STDERR "cannot get service port: $port ";
	    return -1;
	} 
    }
#    print "port = $port\n";    
    my $host_ip = inet_aton($hostname);
#    print "host = $host_ip \n";	
    $entry = sockaddr_in($portnum, inet_aton($hostname));
    connect($sock, $entry) || die "connect : $!";
    # Stop buffering 
    select($sock); $| =1; select(STDOUT);
    $pkg->{host} =$hostname;
    $pkg->{port} =$portnum;
    $pkg->{sock}=$sock;
    return 0;
}

sub Write($$){
    my $pkg=shift;
    my $msg = shift;
    my $sock = $pkg->{sock};
    unless(defined($sock)){
	print STDERR "Socket is not opened yet\n";
	return -1;
    }else{
#	print STDERR "Write cmd: $msg";
	print $sock $msg;
#	my $ret = <$sock>;
#	print "$ret\n";
	return 0;
    }
}

sub Read($){
    my $pkg=shift;
    my $sock = $pkg->{sock};
    unless(defined($sock)){
	print STDERR "Socket is not opened yet\n";
	return "";
    }else{
	my $msg = <$sock>;
	return $msg;
    }
}

sub Close($){
    my $pkg=shift;
    my $sock = $pkg->{sock};
    close($sock);
}


sub tcp_server ($$) {
    my ($S, $port) = @_;
    my $pack = caller;
    $S = $pack . "::" . $S;
    $port = $port || 32001;
    $proto = getprotobyname('tcp');
    $port = getservbyname($port, 'tcp') unless $port =~/^\d+/;

    socket($S, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";
    $ent = sockaddr_in($port, INADDR_ANY);
    bind($S, $ent) || die "bind $!";
    listen($S,5) || die "listen: $!";
}


#
# Usage:  tcp_client HANDLE [, HOST [, PORT=32001]]
#
sub tcp_client ($;$$) {
    my ($S, $host, $port) = @_;
    my $pack = caller;
    $S = $pack . "::" . $S;
    $host = $host || "localhost";
    $port = $port || 32001;

    my $proto = getprotobyname('tcp');
    socket($S, PF_INET, SOCK_STREAM, $proto);
    $port = getservbyname($port, 'tcp') unless $port =~ /^\d+/;
    unless( $port =~ /^\d+/){
	print "cannot get port: $port ";
	exit(1);
    } 
print "port = $port\n";    
    my $host_ip = inet_aton($host);
    $ent = sockaddr_in($port, $host_ip);
    printf "host = %s\n", $host;
    connect($S, $ent) || die "connect : $!";
    # Stop buffering 
    select($S); $| =1; select(STDOUT);
}

1;




















