# @Version: $Id: VLBI_rlk.pm 51 2014-11-30 08:59:12Z sekido $
# Module for VLBI Analysis (Clock+Residual) data 
package VLBI_rlk;
use Exporter;
use Carp;

@ISA = qw(Exporter);

use Time_lib;

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$){
    my $pkg = shift;
    my $fname = shift;
    
    unless(open(IN, $fname)){
	print STDERR "Error: VLBI_rlk::Read(): Failed to opne file($fname)\n";
	return -1;
    }
    
    my (@td, @tderr, @tarr);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	my @terms = split(/[\s]+/);
	unless($terms[0] =~/(\d+\.\d{3})\.([\d:.]+)/){
	    print "Error: VLBI_rlk::Read(): Time Format is unexpected($terms[0]) \n";
	    return -1;
	}
	my @ydhms = ($1,$2);
	$td[$cnt] = $terms[2];
	$tderr[$cnt] = $terms[3];
	my $t1 = new Time_lib;
	$t1->Set_time_strydhms(@ydhms);
	$tarr[$cnt] = $t1;
	$cnt++;
    }

    close(IN);
    $pkg->{TimeArr} = \@tarr;
    $pkg->{TD} = \@td;
    $pkg->{TDerr} = \@tderr;
    
    return $cnt;
}

# Time Difference Array 
sub TDarr($){ # [nsec]
    my $pkg = shift;
    return @{$pkg->{TD}};
}

# Time Difference Error Array 
sub TDErrarr($){ # [nsec]
    my $pkg = shift;
    return @{$pkg->{TDerr}};
}

sub Tarr($){
    my $pkg = shift;
    return @{$pkg->{TimeArr}};
}


1;
