## Read XY data 
##  by M.S.  2011/12/31
##    <X>  <Y>  
###
# @Version: $Id: XY_dat.pm 86 2016-04-13 07:44:27Z sekido $
#
package XY_dat;
use Exporter;
use Carp;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Xarr($){
    my $pkg = shift;
    @{$pkg->{xarr}};
}

sub Yarr($){
    my $pkg = shift;
    @{$pkg->{yarr}};
}

sub Comment($){
    my $pkg = shift;
    @{$pkg->{comment}};
}


sub Read($$){
    my ($pkg,$fname) = @_;
    unless(open(IN,$fname) ){
	print STDERR "Error: Failed to open file($fname) \n";
	return -1;
    }
    my (@xarr, @yarr, @cmt, %has1, %has2);
    my $cnt=0;
    my $icmt=0;
    while(<IN>){
	if(/^\#/){chomp; $cmt[$icmt++] = $_; next;}
	if(/\s*(\S+)\s+(\S+)/){
	    $has1{$1}=$2;
	    $has2{$2}=$1;
	    $xarr[$cnt] = $1;
	    $yarr[$cnt++] = $2;
	}
    }
    $pkg->{xarr}=\@xarr;
    $pkg->{yarr}=\@yarr;
    $pkg->{HashXY} =\%has1;
    $pkg->{HashYX} =\%has2;
    $pkg->{comment}=\@cmt;
    return $cnt;
}
# name, n1,d1,n2,d2
# Sperating by using substr($str, n1,d1), and sibstr(n2,d2)
sub Read_nm($$$$$$){
    my ($pkg,$fname,$n1,$d1,$n2,$d2) = @_;
    unless(open(IN,$fname) ){
	print STDERR "Error: Failed to open file($fname) \n";
	return -1;
    }
    my (@xarr, @yarr, @cmt, %has1, %has2);
    my $cnt=0;
    my $icmt=0;
    my $line = <IN>;
    while( !eof(IN) ){
	if($line=~/^\#/){chomp; $cmt[$icmt++] = $_; next;}
	my $x = substr($line,$n1,$d1);
	my $y = substr($line,$n2,$d2);
	$has1{$x}=$y;
	$has2{$y}=$x;
	$xarr[$cnt] = $x;
	$yarr[$cnt++] = $y;
    }continue{
	$line = <IN>;
    }
    $pkg->{xarr}=\@xarr;
    $pkg->{yarr}=\@yarr;
    $pkg->{HashXY} =\%has1;
    $pkg->{HashYX} =\%has2;
    $pkg->{comment}=\@cmt;
    return $cnt;
}

sub HashXY( ){
    my $pkg = shift;
    return $pkg->{HashXY};
}
sub HashYX( ){
    my $pkg = shift;
    return $pkg->{HashYX};
}

sub Init(){
    delete $pkg->{xarr};
    delete $pkg->{yarr};
    delete $pkg->{comment};
}

1;
