# @Version: $Id: Time_lib.pm 17 2013-12-08 09:47:43Z sekido $
#
package vectopr;

use Math::Matrix;
BEGIN{
    $PI = 4.*atan2(1,1);
    $deg2rad = $PI / 180.;
}
sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

## Rotation matix around X
## input theta [deg.]
sub Rx($){
    my $theta = shift;
    my $rth = $theta * $deg2rad;
    my $c = cos($rth);
    my $s = sin($rth);
    my $m = new Math::Matrix(
	[1, 0,0],
	[0,$c,$s],
	[0,-$s,$c]);
    return $m;
}

## Rotation matix around Y
## input theta [deg.]
sub Ry($){
    my $theta = shift;
    my $rth = $theta * $deg2rad;
    my $c = cos($rth);
    my $s = sin($rth);
    my $m = new Math::Matrix(
	[ $c, 0, -$s],
	[ 0,  1,  0],
	[ $s, 0,  $c]);
    return $m;
}

## Rotation matix around Z
## input theta [deg.]
sub Rz($){
    my $theta = shift;
    my $rth = $theta * $deg2rad;
    my $c = cos($rth);
    my $s = sin($rth);
    my $m = new Math::Matrix(
	[ $c, $s, 0],
	[-$s, $c, 0],
	[  0, 0,  1]);
    return $m;
}

1;
